//+-------------------------------------------------------------------+
//|                                                       ATL_v14.mq4 |
//|                                                              nen  |
//|                                                          http://  |
//+-------------------------------------------------------------------+
//|                                                                   |
//+-------------------------------------------------------------------+
//|AddLines -                                  |
//+-------------------------------------------------------------------+
//|                                                                   |
//|                                                          |
//|  00 - ,                                  |
//|  01 - ,   High-High                          |
//|  02 - ,   Low-Low                            |
//|  03 - ,   High-Low                           |
//|  04 - ,   Low-High                           |
//|  05 - ,   Close-Close                        |
//|  06 -     ( )          |
//+-------------------------------------------------------------------+
//|                                                                   |
//|ColorLines -                                        |
//+-------------------------------------------------------------------+
//|                 "Properties Lines"                                |
//+-------------------------------------------------------------------+
//|                                                                   |
//|NumberLines -   ,             |
//|                                                          |
//|ShowReactionLines -                         |
//|            0 -                            |
//|            1 -                                |
//|            2 -   1                     |
//|            3 -   2                     |
//|            4 -                  |
//|            5 -   1,  1    |
//|            6 -   2,  2    |
//|            7 -   1,  1  , |
//|                                              |
//|            8 -   2,  2  , |
//|                                              |
//|            9 -   1,          |
//|                      |
//|            10 -    1                   |
//|                                                                   |
//|                                                                   |
//|PriceLabelOnLines -        |
//|                     ()                          |
//|            1 -     ,  |
//|                                              |
//|            2 -               |
//|                                                                   |
//|NameLines -                                  |
//|            1 - LT -                                    |
//|            2 - LC -                                     |
//|            3 - LP -                                |
//|                                                                   |
//|VariantsOfProcessingLines -                  |
//|            1 -          | 
//|                           |
//|                                                                   |
//|            8 -     ,          |
//|                                           |
//|                                                                   |
//|            9 -     ,          |
//|                   .       |
//|                   .             |
//|                                                                   |
//|NumberLinesConnected -  ,         |
//|                        NumberLines                           |
//|                                                                   |
//|FiboTime -     FiboTime                          |
//|            1 - FiboTime                |
//|                                              |
//|            2 - FiboTime                  |
//|            3 -  QuantityCycles           |
//|                                                                   |
//+-------------------------------------------------------------------+
//|               "Additional Properties Lines"                       |
//+-------------------------------------------------------------------+
//|ShowNumberLines -            |
//|                                                  |
//|                                                                   |
//|ColorReactionLines -                         |
//|ColorActionLines   -                        |
//|ColorLevelLines -          |
//|                                                                   |
//|WidthLines -                                     |
//|StyleLines -                                       |
//|                                                                   |
//|LevelReactionLines -                   |
//|WidthReactionLines -                      |
//|StyleReactionLines -                        |
//|SizeLevelLines -        |
//|                                                                   |
//|PeakCurrentTime - ,           |
//|                                                      |
//|          true -                                |
//|          false -                              |
//|                                                                   |
//|FiboTimeFree -     FiboTime                |
//|FiboTimeColorList -     FiboTime             |
//|WidthFiboTime -     FiboTime              |
//|StyleFiboTime -     FiboTime                |
//|                                                                   |
//|AllObjectsOfOneColor  =true   ,    |
//|                             |
//|                                             |
//|                      =false           |
//|                                      |
//|                                                                   |
//|QuantityCycles -                   |
//|                                                                   |
//|delta -        |
//|                                                          |
//|                                                                   |
//+-------------------------------------------------------------------+
#property copyright "nen"
#property link      "http://"

#property stacksize 65535
#property indicator_chart_window

extern bool   AddLines   = false;
extern color  ColorLines = Red;

extern string ______________0_____________ = "Properties Lines";  
extern int    NumberLines              = 0;
extern int    ShowReactionLines        = 0;
extern int    PriceLabelOnLines        = 0;

extern int    NameLines                = 0; //  .  .   . LC, LP

extern int    VariantsOfProcessingLines= 0; //   
extern int    NumberLinesConnected     = 0; //  ,     NumberLines
extern int    FiboTime                 = 0;

extern string ______________1_____________ = "Additional Properties Lines";
extern bool   AllObjectsOfOneColor = true;
extern color  ColorReactionLines   = DodgerBlue;
extern color  ColorActionLines     = DodgerBlue;
extern color  ColorLevelLines      = DodgerBlue;
extern int    infoLines            = 1;  //          .
extern int    infoVariants         = 0;
extern int    WidthLines           = 0;
extern int    StyleLines           = 2;
extern string LevelReactionLines   = "-0.382,-0.618,0.382,0.618,1.0,1.272,1.618,2.0,2.618,3.618,4.618";
extern int    WidthReactionLines   = 0;
extern int    StyleReactionLines   = 2;
extern int    SizeLevelLines       = 8;
extern bool   PeakCurrentTime      = true;
extern string FiboTimeColorList    = "Gray,CadetBlue,DarkSlateGray,LightGoldenrod";
extern int    WidthFiboTime        = 0;
extern int    StyleFiboTime        = 2;
extern string FiboTimeFree         = "0.618,1.0,1.618";
extern bool   ShowNumberLines      = true;
extern int    missedBars           = 2;
extern int    QuantityCycles       = 6; 
extern int    delta                = 5;


string nameObj="", typeObj="";
bool   moveATL=true, newBar=false, Transformation=false, TransformationMax=false;
string countLines="000"; //    
string TF[]={"0","1","2","3","4","5","6","7","8"};
string txtTF[]={"M1","M5","M15","M30","H1","H4","D1","W1","MN1"};
datetime NewBarTF[9];
int    QuantityLinesTF[9]; //     
string numTF,numTF0,numTF1,numTF2;
string friendLines="000"; //   ,     
string PropertiesLines="0000000000"; //  
//  ,  
double fi[];
string fitxt[];
string fitxt100[];
int    Sizefi;
//
datetime _tf[]={PERIOD_M1,PERIOD_M5,PERIOD_M15,PERIOD_M30,PERIOD_H1,PERIOD_H4,PERIOD_D1,PERIOD_W1,PERIOD_MN1};
bool     _atl[1];      //    .
int      _csw[1,3];    //  Color-Style-Width 

int      _type[1];     //   
int      _friend[1];   //    
int      _numTf[1,3];  //  numTF
int      _pl[1,10];    //   
double   _cena[1,2];   //    
datetime _time[1,2];   //    
string   _name[1];     //   
double   _h1[1,2];     //     Action
int      col;          //  .  

string prefics="_#";
string cCenaAdd1="",cCenaAdd2="";
int    cCenaLen=8;
int    vX, vY; //   X
int    chartchange=0;
double coordinataCena1, coordinataCena2, cCena1, cCena2;
datetime coordinataTime1, coordinataTime2, cTime1, cTime2;
color  aColorLines;
int    aStyleLines, aWidthLines;
color  ColorList[];
int    ColorSize, ftSize;
double ft[];
string fttxt[];
string accountCompany="";
bool   changeAccount=false;
bool   ShowNumberLines_=false;
bool   PriceLabelOnLines_=false;
bool   VariantsOfProcessingLines_=false;
double lBar, hBar;
int    tfZZ=10; //  ,     
datetime tiZZ;
//      
double   cenaX;
datetime timeX;


//string otladka="";


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

   string aa,aa1;
   int aa2, i;
   typeObj="00";
   vX=30; vY=30; //   X

//   if (StringLen(DoubleToStr(High[1],Digits))<7) cCenaAdd="0";

   numTF=_period(Period());

   aColorLines=ColorLines;
   aStyleLines=StyleLines;
   aWidthLines=WidthLines;

   ShowNumberLines_=true;

   nameObj="CheckLabel";
   if (ObjectFind(nameObj)==0)
     {
      ObjectSet(nameObj, OBJPROP_COLOR, Red);
      WindowRedraw();
     }

   if (NumberLines<0) NumberLines=0;

   if (ShowReactionLines<0) ShowReactionLines=0;
   if (ShowReactionLines>10) ShowReactionLines=10;

   if (PriceLabelOnLines<0) PriceLabelOnLines=0;
   if (PriceLabelOnLines>4) PriceLabelOnLines=4;

   if (FiboTime<0) FiboTime=0;
   if (FiboTime>3) FiboTime=3;

   if (NameLines<0) NameLines=0;
   if (NameLines>3) NameLines=3;

   if (VariantsOfProcessingLines<0) VariantsOfProcessingLines=0;
   if (VariantsOfProcessingLines>9) VariantsOfProcessingLines=9;

   if (ArraySize(NewBarTF)>0) ArrayInitialize(NewBarTF,0);

//   if (ShowReactionLines>0)
   i=-1;
   aa2=0;
   Sizefi=0;
   while (aa2>=0)
     {
      aa2=StringFind(LevelReactionLines, ",",i+1);
      if (aa2>=0)
        {i=aa2;Sizefi++;}
      else
        {
         if (StringLen(LevelReactionLines)-i>0)
           {
            if (StrToDouble(StringSubstr(LevelReactionLines,i+1))>0) Sizefi++;
            ArrayResize(fi,Sizefi);
            ArrayResize(fitxt,Sizefi);
            ArrayResize(fitxt100,Sizefi);
            aa1=LevelReactionLines;
            for (i=0;i<Sizefi;i++)
              {
               aa2=StringFind(aa1, ",", 0);

               fitxt[i]=StringTrimLeft(StringTrimRight(StringSubstr(aa1,0,aa2)));
               fi[i]=StrToDouble(fitxt[i]);
               if (fi[i]<1) fitxt[i]=StringSubstr(fitxt[i],1);
               fitxt100[i]=DoubleToStr(100*fi[i],1);

               if (aa2>=0) aa1=StringSubstr(aa1,aa2+1);
              }
           }
        }
     }


   i=-1;
   aa2=0;
   ftSize=0;
   while (aa2>=0)
     {
      aa2=StringFind(FiboTimeFree, ",",i+1);
      if (aa2>=0)
        {i=aa2;ftSize++;}
      else
        {
         if (StringLen(FiboTimeFree)-i>0)
           {
            if (StrToDouble(StringSubstr(FiboTimeFree,i+1))>0) ftSize++;
            ArrayResize(ft,ftSize);
            ArrayResize(fttxt,ftSize);
            aa1=FiboTimeFree;
            for (i=0;i<ftSize;i++)
              {
               aa2=StringFind(aa1, ",", 0);

               fttxt[i]=StringTrimLeft(StringTrimRight(StringSubstr(aa1,0,aa2)));
               ft[i]=StrToDouble(fttxt[i]);
               if (ft[i]<1) fttxt[i]=StringSubstr(fttxt[i],1);

               if (aa2>=0) aa1=StringSubstr(aa1,aa2+1);
              }
            aa2=-1;
           }
        }
     }

   i=-1;
   aa2=0;
   ColorSize=0;
   while (aa2>=0)
     {
      aa2=StringFind(FiboTimeColorList, ",",i+1);
      if (aa2>=0)
        {i=aa2;ColorSize++;}
      else
        {
         if (StringLen(FiboTimeColorList)-i>0)
           {
            if (StrToDouble(StringSubstr(FiboTimeColorList,i+1))>0) ColorSize++;
            ArrayResize(ColorList,ColorSize);
            aa1=FiboTimeColorList;
            for (i=0;i<ColorSize;i++)
              {
               aa2=StringFind(aa1, ",", 0);
               ColorList[i]=fStrToColor(StringTrimLeft(StringTrimRight(StringSubstr(aa1,0,aa2))));
               if (aa2>=0) aa1=StringSubstr(aa1,aa2+1);
              }
            aa2=-1;
           }
        }
     }

   _createArray();

   if (missedBars<0) missedBars=0;
   if (QuantityCycles<0) QuantityCycles=0;

   if (UninitializeReason()==3) chartchange=2;
   if (UninitializeReason()==5) chartchange=1;

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----

   int i;
   bool x=false;

   for (i=0; i<col; i++)
     {
      if (_atl[i]) {x=true; break;}
     }

   nameObj="CheckLabel";
   if (x)
     {
      ObjectSet(nameObj, OBJPROP_COLOR, Blue);
      WindowRedraw();
      moveATL=true;
     }
   else
     {
      ObjectDelete(nameObj);
     }

   Comment("");
//Print ("===DEINIT_ATL ===");
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   RefreshAccountInfo();

   nameObj="CheckLabel";

   //    
   if (ObjectFind(nameObj)<0 || ObjectGet(nameObj,OBJPROP_XDISTANCE)!=vX || ObjectGet(nameObj,OBJPROP_YDISTANCE)!=vY || ObjectGet(nameObj,OBJPROP_COLOR)==Blue)
     {
      ObjectDelete(nameObj);
      ObjectCreate(nameObj,OBJ_LABEL,0,0,0);

      ObjectSetText(nameObj,"X");
      ObjectSet(nameObj, OBJPROP_FONTSIZE, 14);
      ObjectSet(nameObj, OBJPROP_COLOR, Red);

      ObjectSet(nameObj, OBJPROP_CORNER, 1);
      ObjectSet(nameObj, OBJPROP_XDISTANCE, vX);
      ObjectSet(nameObj, OBJPROP_YDISTANCE, vY);

      moveATL=true;
     }

   //  
   if (AddLines)
     {
      counted_objects();
      
      if (countLines!="***")
        {
         if (StrToInteger(countLines)==col+1) {col++; _arrayResize(col);}
         coordinaty_lines();
         typeObj="00";
         numTF0=numTF; 
         numTF1=numTF; 
         numTF2=numTF;
         nameObj=prefics+typeObj+countLines+friendLines+PropertiesLines+numTF0+numTF1+numTF2+time_str(coordinataTime1)+cCenaAdd1+DoubleToStr(coordinataCena1,Digits)+time_str(coordinataTime2)+cCenaAdd2+DoubleToStr(coordinataCena2,Digits);

         Create_lines();
        }
     }

//  
   if (lBar>iLow(NULL,_tf[tiZZ],0) || hBar<iHigh(NULL,_tf[tfZZ],0) || tiZZ!=iTime(NULL,_tf[tfZZ],0) || chartchange>0)
     {
//Print(" ");
      lBar=iLow(NULL,_tf[tfZZ],0); hBar=iHigh(NULL,_tf[tfZZ],0);

      //   
       _reaction();

      // c    
//      if (tiZZ!=iTime(NULL,_tf[tfZZ],0))
        {
         tiZZ=iTime(NULL,_tf[tfZZ],0);
         if (PriceLabelOnLines_) {_PriceLabelOnLines_1();}
        }
 
      //   
      if (VariantsOfProcessingLines_) _VariantsOfProcessingLines();
     }

   //       
   if (moveATL) updating_objects(numTF);

   if (infoLines>0) _infoLines();

   //  
   if (chartchange>0)
     {
      moveATL=true; 
      chartchange--;
     }
   else moveATL=false;

   AddLines=false;
   return(0);
  }
//--------------------------------

//--------------------------------------------------------
//    . .
//--------------------------------------------------------
void _createArray()
  {
   int i, j=0, k, obj_total=ObjectsTotal();

   for (i=0; i<=obj_total && obj_total>0; i++)
     {
      nameObj=ObjectName(i);
      if (StringSubstr(nameObj,0,2)==prefics) 
        {
         k=StrToInteger(StringSubstr(nameObj,4,3));
         if (j<k) j=k;
        }
      else if (StringSubstr(nameObj,0,13)=="_NumberLines_") 
        {
         k=StrToInteger(StringSubstr(nameObj,13,3));
         if (j<k) j=k;
        }
      else if (StringSubstr(nameObj,0,8)=="Action") 
        {
         k=StrToInteger(StringSubstr(nameObj,8,3));
         if (j<k) j=k;
        }
      else if (StringSubstr(nameObj,0,10)=="Reaction") 
        {
         k=StrToInteger(StringSubstr(nameObj,10,3));
         if (j<k) j=k;
        }
      else if (StringSubstr(nameObj,0,6)=="Level") 
        {
         k=StrToInteger(StringSubstr(nameObj,6,3));
         if (j<k) j=k;
        }
      else if (StringSubstr(nameObj,0,2)=="ft") 
        {
         k=StrToInteger(StringSubstr(nameObj,4,3));
         if (j<k) j=k;
        }
      }

   col=j;

   _arrayResize(j);

   if (ArraySize(_atl)>0) ArrayInitialize(_atl,false);


   for (i=0; i<=obj_total; i++)
     {
      nameObj=ObjectName(i);
      if (StringSubstr(nameObj,0,2)==prefics) 
        {
         k=StrToInteger(StringSubstr(nameObj,4,3))-1;

         _writeArray(k);
        }
      }

// ,        ,    
   for (i=0; i<j; i++)
     {
      if (!_atl[i])
        {
         if (i==1000) break;
         _delete_obj(i);
        }
     }
  }
//--------------------------------------------------------
//    . .
//--------------------------------------------------------


//--------------------------------------------------------
//   ,    . .
//--------------------------------------------------------
void _delete_obj(int i)
  {
   int k=i+1;

   if (k<10) countLines="00"+k;
   else if (k<100) countLines="0"+k;
   else if (k<1000) countLines=""+k;

   ObjectDelete("_NumberLines_"+countLines);
   ObjectDelete("PLOL_"+countLines);
   ObjectDelete("vLine"+k);
   ObjectDelete("hLine"+k);
   delete_a_reaction();
   ObjectDelete("ft1_"+countLines);
   ObjectDelete("ft2_"+countLines);
   ObjectDelete("ft3_"+countLines);
   ObjectDelete("ft4_"+countLines);
  }
//--------------------------------------------------------
//   ,    . .
//--------------------------------------------------------


//--------------------------------------------------------
//    . .
//--------------------------------------------------------
void _arrayResize(int j)
  {
   ArrayResize(_atl,j);
   ArrayResize(_csw,j);
   ArrayResize(_type,j);
   ArrayResize(_friend,j);
   ArrayResize(_numTf,j);
   ArrayResize(_pl,j);
   ArrayResize(_cena,j);
   ArrayResize(_time,j);
   ArrayResize(_name,j);
   ArrayResize(_h1,j);
  }
//--------------------------------------------------------
//    . .
//--------------------------------------------------------


//--------------------------------------------------------
//     . .
//--------------------------------------------------------
void _writeArray(int k)
  {
   int i;
   if (StringLen(nameObj)<59) {ObjectDelete(nameObj);return;}
   //    . 1  -   , 2 -  
   _atl[k]=true;
   //  Color-Style-Width 
   _csw[k,0]=ObjectGet(nameObj,OBJPROP_COLOR); _csw[k,1]=ObjectGet(nameObj,OBJPROP_STYLE); _csw[k,2]=ObjectGet(nameObj,OBJPROP_WIDTH);
   //   
   _type[k]=StrToInteger(StringSubstr(nameObj,2,2));
   //    
   _friend[k]=StrToInteger(StringSubstr(nameObj,7,3));
   //  numTF
   _numTf[k,0]=StrToInteger(StringSubstr(nameObj,20,1)); _numTf[k,1]=StrToInteger(StringSubstr(nameObj,21,1)); _numTf[k,2]=StrToInteger(StringSubstr(nameObj,22,1));
   //    
   _time[k,0]=StrToInteger(StringSubstr(nameObj,23,10)); _time[k,1]=StrToInteger(StringSubstr(nameObj,41,10));
   //    
   _cena[k,0]=StrToDouble(StringSubstr(nameObj,33,cCenaLen)); _cena[k,1]=StrToDouble(StringSubstr(nameObj,51,cCenaLen));
   //   
   _name[k]=nameObj;

   //   
   for (i=0;i<10;i++)
     {
      _pl[k,i]=StringGetChar(StringSubstr(_name[k],10+i,1),0)-48;
     }
  }
//--------------------------------------------------------
//     . .
//--------------------------------------------------------


//--------------------------------------------------------
//  -    . .
//--------------------------------------------------------
void updating_objects(string tfwork)
  {
   int j, k, tf;
   int cc1, cc2, co1, co2;
   string txt, t0;
   tfZZ=10;

   VariantsOfProcessingLines_=false;
   PriceLabelOnLines_=false;

   for (k=0; k<col; k++)
     {
      if (!_atl[k]) continue;
      if (ObjectFind(_name[k])<0)
        {
         _atl[k]=false; 
         _delete_obj(k);
         continue;
        }

      txt=_name[k];
      nameObj=txt;

      if (StringSubstr(txt,0,2)==prefics) 
        {
         if (StringLen(nameObj)<59) {ObjectDelete(nameObj);continue;}
         if (ArraySize(QuantityLinesTF)>0) ArrayInitialize(QuantityLinesTF,0);

         typeObj=StringSubstr(txt,2,2);
         //  
         cTime1=ObjectGet(txt,OBJPROP_TIME1);
         cTime2=ObjectGet(txt,OBJPROP_TIME2);
         cCena1=NormalizeDouble(ObjectGet(txt,OBJPROP_PRICE1),Digits);
         cCena2=NormalizeDouble(ObjectGet(txt,OBJPROP_PRICE2),Digits);

         //  
         coordinataTime1=_time[k,0];
         coordinataTime2=_time[k,1];
         coordinataCena1=_cena[k,0];
         coordinataCena2=_cena[k,1];

         //    .     double.
         cc1=MathRound(cCena1/Point);
         cc2=MathRound(cCena2/Point);
         co1=MathRound(coordinataCena1/Point);
         co2=MathRound(coordinataCena2/Point);

         numTF0=StringSubstr(txt,20,1);  //  ,    .
         numTF1=StringSubstr(txt,21,1);  //  ,      
         if (numTF1=="-") numTF1=numTF2;
         numTF2=StringSubstr(txt,22,1);  // ,      

// otladka=StringSubstr(txt,20,3);

         countLines=StringSubstr(txt,4,3);
         friendLines=StringSubstr(txt,7,3);
         PropertiesLines=StringSubstr(txt,10,10);
//Print("countLines=",countLines);

         aColorLines=_csw[k,0];
         aStyleLines=_csw[k,1];
         aWidthLines=_csw[k,2];

   //   
//         if (cTime1!=coordinataTime1 || cc1!=co1 || cTime2!=coordinataTime2 || cc2!=co2 || typeObj=="00" || changeAccount)
         if (cTime1!=coordinataTime1 || cc1!=co1 || cTime2!=coordinataTime2 || cc2!=co2)
           {
            //     numTF0 : 
            //    ( 00),     ,
            // 
            //   = 00,    
            //  numTF2 = numTF0
// Print("======2======  =changeAccount=");
// Print("countLines=",countLines);

            coordinataTime1=cTime1;
            coordinataTime2=cTime2;
            coordinataCena1=cCena1;
            coordinataCena2=cCena2;

            search_bar(_tf[StrToInteger(tfwork)]);

            numTF0=tfwork;
            numTF1=tfwork;
            numTF2=tfwork;
            ObjectDelete(txt);
            if (ObjectFind(txt)>-1) continue;

            _cCenaAdd();
            nameObj=prefics+typeObj+countLines+friendLines+PropertiesLines+numTF0+numTF1+numTF2+time_str(coordinataTime1)+cCenaAdd1+DoubleToStr(coordinataCena1,Digits)+time_str(coordinataTime2)+cCenaAdd2+DoubleToStr(coordinataCena2,Digits);
            if (StringLen(nameObj)<59) {ObjectDelete(nameObj);continue;}
            Create_lines();
           }
         else if (cTime1==coordinataTime1 && cc1==co1 && cTime2==coordinataTime2 && cc2==co2 && tfwork<numTF0)
           {
            //       ,     numTF0,     ,
            //  numTF2  
//      Print("======1======");

            if (search_bar(_tf[_numTf[k,2]]))
              {
               ObjectDelete(txt);
               _cCenaAdd();
               nameObj=prefics+typeObj+countLines+friendLines+PropertiesLines+numTF0+numTF1+numTF2+time_str(coordinataTime1)+cCenaAdd1+DoubleToStr(coordinataCena1,Digits)+time_str(coordinataTime2)+cCenaAdd2+DoubleToStr(coordinataCena2,Digits);
               Create_lines();
              }
           }
         else if (PeakCurrentTime && numTF2!=numTF0 && _type[k]>0 && _type[k]<6) 
           {
//      Print("======\/======");
            // .     . 
            Transformation=true;
            search_bar(_tf[_numTf[k,1]]);
            numTF0=StringSubstr(txt,20,1);
            numTF2=numTF0;
            ObjectDelete(txt);
            _cCenaAdd();
            nameObj=prefics+typeObj+countLines+friendLines+PropertiesLines+numTF0+numTF1+numTF2+time_str(coordinataTime1)+cCenaAdd1+DoubleToStr(coordinataCena1,Digits)+time_str(coordinataTime2)+cCenaAdd2+DoubleToStr(coordinataCena2,Digits);
            Create_lines();
            Transformation=false;
           }
         else if (!PeakCurrentTime && numTF2!=numTF1 && _type[k] && _type[k]<6)
           {
//      Print("======/\======");
            // .     .
            TransformationMax=true;
            search_bar(_tf[_numTf[k,1]]);
            numTF0=StringSubstr(txt,20,1);
            numTF2=numTF1;
            ObjectDelete(txt);
            _cCenaAdd();
            nameObj=prefics+typeObj+countLines+friendLines+PropertiesLines+numTF0+numTF1+numTF2+time_str(coordinataTime1)+cCenaAdd1+DoubleToStr(coordinataCena1,Digits)+time_str(coordinataTime2)+cCenaAdd2+DoubleToStr(coordinataCena2,Digits);
            Create_lines();
            TransformationMax=false;
           }

         if (tfZZ>_numTf[k,0]) {tfZZ=_numTf[k,0];} //   ,    

//-----
   //   
//      if (StrToInteger(typeObj)>0) _PropertiesLine();
         _PropertiesLine();

         //       
//         numTF0=StringSubstr(nameObj,20,1);
         if (_type[k]>0)
           {
            if (_pl[k,2]>0)
              {
               QuantityLinesTF[StrToInteger(numTF0)]++; 
               PriceLabelOnLines_=true;
              }

            if (_type[k]==1 || _type[k]==2)
              {
               if (_pl[k,4]>0 && !VariantsOfProcessingLines_)
                 {
                  VariantsOfProcessingLines_=true;
                 }
              }

           }

         if (ShowNumberLines_) _NumberLines();
//-----
        } 
     }
   if (!PriceLabelOnLines_ && ArraySize(NewBarTF)>0) ArrayInitialize(NewBarTF,0);
   NumberLines=0;
   changeAccount=false;
   ShowNumberLines_=false;
  }
//--------------------------------------------------------
//  -    . .
//--------------------------------------------------------

//--------------------------------------------------------
//   . .
//--------------------------------------------------------
void _PropertiesLine()
  {
   int i, k, n;
   string txt, pl="";

   k=StrToInteger(countLines)-1;
   if (_type[k]>0 && _type[k]<3)
     {
      n=0; //   
      if (ShowReactionLines>0 && NumberLines>0 && NumberLines==StrToInteger(countLines))
        {
         txt=nameObj;
         if (_pl[k,n]>0 && _pl[k,n]==ShowReactionLines) _pl[k,n]=0; else _pl[k,n]=ShowReactionLines;
         pl=StringSetChar(pl,0,_pl[k,n]+48);
//         pl=""+_pl[k,n];
         nameObj=StringSetChar(txt,10+n,StringGetChar(pl,0));
         ObjectDelete(txt);
         Create_lines();
         _reaction();
        }
      else if (_pl[k,n]>0)
        {
         _reaction();
        }

      n=1; //  FiboTime
      if (FiboTime>0 && NumberLines>0 && NumberLines==StrToInteger(countLines))
        {
         txt=nameObj;
         if (_pl[k,n]>0 && _pl[k,n]==FiboTime) _pl[k,n]=0; else _pl[k,n]=FiboTime;
         pl=StringSetChar(pl,0,_pl[k,n]+48);
//         pl=""+_pl[k,n];
         nameObj=StringSetChar(txt,10+n,StringGetChar(pl,0));
         ObjectDelete(txt);
         Create_lines();
         _fiboTimeMulty();
        }
      else if (_pl[k,n]>0)
        {
         _fiboTimeMulty();
        }

      n=3; //    
      if (NameLines>0 && NumberLines>0 && NumberLines==StrToInteger(countLines))
        {
         txt=nameObj;
         if (_pl[k,n]>0 && _pl[k,n]==NameLines) _pl[k,n]=0; else _pl[k,n]=NameLines;
         pl=StringSetChar(pl,0,_pl[k,n]+48);
//         pl=""+_pl[k,n];
         nameObj=StringSetChar(txt,10+n,StringGetChar(pl,0));
         ObjectDelete(txt);
         Create_lines();
        }

      n=4; //   
      if (VariantsOfProcessingLines>0 && NumberLines>0 && NumberLines==StrToInteger(countLines))
        {
         txt=nameObj;
         if (_pl[k,n]>0 && _pl[k,n]==VariantsOfProcessingLines)
           {
            if (VariantsOfProcessingLines==1)
              {
               ObjectDelete("vLine"+(k+1));
               ObjectDelete("hLine"+(k+1));
              }

            _pl[k,n]=0;
           }
         else {_pl[k,n]=VariantsOfProcessingLines;}

         pl=StringSetChar(pl,0,_pl[k,n]+48);
//         pl=""+_pl[k,n];
         nameObj=StringSetChar(txt,10+n,StringGetChar(pl,0));
         ObjectDelete(txt);
         Create_lines();
         _VariantsOfProcessingLines(); //   
        }
      else if (_pl[k,n]>0)
        {
         _VariantsOfProcessingLines();
        }

       //   NumberLines   NumberLinesConnected
       if (NumberLinesConnected>0 && NumberLines>0 && NumberLines==StrToInteger(countLines))
        {
         txt=nameObj;
//         friendLines=StringSubstr(txt,7,3);
         if (friendLines!="000" && StrToInteger(friendLines)==NumberLinesConnected) friendLines="000";
         else
           {
            friendLines=""+NumberLinesConnected;
            int len_friendLines=StringLen(friendLines);
            if (len_friendLines==1) friendLines="00"+NumberLinesConnected;
            else if (len_friendLines==2) friendLines="0"+NumberLinesConnected;
           }
         nameObj=StringSubstr(txt,0,7)+friendLines+StringSubstr(txt,10);
         ObjectDelete(txt);
         Create_lines();
        }

     }

   if (_type[k]>0)
     {
      n=2; // c    
      if (PriceLabelOnLines>0 && NumberLines>0 && NumberLines==StrToInteger(countLines))
        {
         txt=nameObj;
         if (_pl[k,n]>0 && _pl[k,n]==PriceLabelOnLines) _pl[k,n]=0; else _pl[k,n]=PriceLabelOnLines;
         pl=StringSetChar(pl,0,_pl[k,n]+48);
//         pl=""+_pl[k,n];
         nameObj=StringSetChar(txt,10+n,StringGetChar(pl,0));
         ObjectDelete(txt);
         Create_lines();
         _PriceLabelOnLines(); // c     
        }
      else if (_pl[k,n]>0)
        {
         _PriceLabelOnLines();
        }
     }

   //     ,           
   if (_type[k]==0)
     {
      ObjectDelete("PLOL_"+countLines);
     }

   if (_type[k]==0 || _type[k]>2)
     {
      delete_a_reaction();
      ObjectDelete("ft1_"+countLines);
      ObjectDelete("ft2_"+countLines);
      ObjectDelete("ft3_"+countLines);
      ObjectDelete("ft4_"+countLines);
     }
  }
//--------------------------------------------------------
//   . .
//--------------------------------------------------------
/*
extern int    NameLines                = 0; //  .  .   .
extern int    VariantsOfProcessingLines= 0; //   
extern int    NumberLinesConnected     = 0; //  ,     NumberLines
*/


//--------------------------------------------------------
//   . .
/*

      .   ,    .

VariantsOfProcessingLines=
1 -   
      ,    ,         .


2 -   ,      .4 ( LC)  .5 ( LP)  .
        .
3 -     .  ,       .
        .
          .

     4-5-6-7   

4 -       .      .
5 -     4  +     .         .
6 -     4  +       6.
7 -     5  +       6.


//8 -   ,  .   .
*/
//--------------------------------------------------------
void _VariantsOfProcessingLines()
  {
   int i, j, k, m, n, point1, point2, point_mem, numFr;
   string txt;
   double tangens, tangens0, tangens_mem, cena0, cena_mem;
   datetime mtf, tf0, tf_mem;
   bool flag_9;

   for (k=0;k<col;k++)
     {
      if (!_atl[k]) continue;
      if (ObjectFind(_name[k])<0)
        {
         _atl[k]=false; 
         _delete_obj(k);
         continue;
        }

      if (_pl[k,4]>0)
        {
         //            
         //     (_pl[k,3]==3)
         if (_pl[k,4]==1 && _pl[k,3]==3)
           {
            numFr=_friend[k]-1;
            if (_numTf[k,0]<=_numTf[numFr,0])
              {
               mtf=_tf[_numTf[numFr,0]];
              }
            else
              {
               mtf=_tf[_numTf[k,0]];
              }

            if (_coordinataX(numFr, k, mtf))
              {
               string vLine, hLine;
               vLine="vLine"+(k+1);
               ObjectDelete(vLine);
               ObjectCreate(vLine,OBJ_VLINE,0,timeX,cenaX);
               ObjectSet(vLine,OBJPROP_COLOR,_csw[k,0]);
               ObjectSet(vLine,OBJPROP_STYLE,_csw[k,1]);
               ObjectSet(vLine,OBJPROP_WIDTH,_csw[k,2]);

               hLine="hLine"+(k+1);
               ObjectDelete(hLine);
               ObjectCreate(hLine,OBJ_HLINE,0,timeX,cenaX);
               ObjectSet(hLine,OBJPROP_COLOR,_csw[k,0]);
               ObjectSet(hLine,OBJPROP_STYLE,_csw[k,1]);
               ObjectSet(hLine,OBJPROP_WIDTH,_csw[k,2]);
              }
           }
         //      .     4.
         //          ,    
         //     5      (    ).
         //          .
         else if (_pl[k,4]==2)
           {
           }
         //      .     4.
         //          ,    
         //     5      (    ).
         //          .
         else if (_pl[k,4]==3)
           {
           }
         //     ,    .
         //    Low-Low (_type[k]==2)  High-High (_type[k]==1)
         // 8 -  . 9 -     .
         else if (_pl[k,4]==8 || _pl[k,4]==9)
           {

            if (Period()>=_tf[_numTf[k,0]])
              {
               mtf=_tf[_numTf[k,1]];
              }
            else continue; //        >=    .

            point1=iBarShift(Symbol(),mtf,_time[k,0],false);
            point2=iBarShift(Symbol(),mtf,_time[k,1],false);

            if (point1<0 || point2<0) return;
            if (point1==point2) continue;

            point_mem=point2;
            cena_mem=_cena[k,1];
            tf_mem=_time[k,1];

            if (_type[k]==1) tangens=(_cena[k,1]-_cena[k,0])/(point1-point2);
            else if (_type[k]==2) tangens=(_cena[k,0]-_cena[k,1])/(point1-point2);

            tangens0=tangens;

            if (chartchange>0)
              {
               for (i=point1-1;i>=0;i--)
                 {
                  if (_type[k]==1)
                    {
                     if ((_cena[k,0]+tangens0*(point1-i))<iHigh(Symbol(),mtf,i))
                       {
                        cena0=iHigh(Symbol(),mtf,i);
                        tf0=iTime(Symbol(),mtf,i);
                        tangens0=(cena0-_cena[k,0])/(point1-i);

                        if (_pl[k,4]==9)
                          {
                           if (i<point_mem-missedBars)
                             {
                              flag_9=true;
                              for (m=0;m<col;m++) if (cena_mem==_cena[m,1] && tf_mem==_time[m,1]) {flag_9=false; break;}

                              if (flag_9)
                                {
                                 counted_objects();

                                 if (countLines!="***")
                                   {
                                    if (StrToInteger(countLines)==col+1) {col++; _arrayResize(col);}

                                    aColorLines=_csw[k,0];
                                    aStyleLines=_csw[k,1];
                                    aWidthLines=_csw[k,2];

                                    coordinataTime1=_time[k,0];
                                    coordinataTime2=tf_mem;
                                    coordinataCena1=_cena[k,0];
                                    coordinataCena2=cena_mem;
                                    _cCenaAdd();
                                    typeObj="01";
                                    nameObj=prefics+typeObj+countLines+"0000000000000"+numTF+numTF+numTF+time_str(coordinataTime1)+cCenaAdd1+DoubleToStr(coordinataCena1,Digits)+time_str(coordinataTime2)+cCenaAdd2+DoubleToStr(coordinataCena2,Digits);

                                    Create_lines();
                                   }
                                }
                             }

                           point_mem=i;
                           cena_mem=cena0;
                           tf_mem=tf0;
                          }

                       }
                    }
                  else if (_type[k]==2)
                    {
                     if ((_cena[k,0]-tangens0*(point1-i))>iLow(Symbol(),mtf,i))
                       {
                        cena0=iLow(Symbol(),mtf,i);
                        tf0=iTime(Symbol(),mtf,i);
                        tangens0=(_cena[k,0]-cena0)/(point1-i);

                        if (_pl[k,4]==9)
                          {
                           if (i<point_mem-missedBars)
                             {
                              flag_9=true;
                              for (m=0;m<col;m++) if (cena_mem==_cena[m,1] && tf_mem==_time[m,1]) {flag_9=false; break;}

                              if (flag_9)
                                {
                                 counted_objects();

                                 if (countLines!="***")
                                   {
                                    if (StrToInteger(countLines)==col+1) {col++; _arrayResize(col);}

                                    aColorLines=_csw[k,0];
                                    aStyleLines=_csw[k,1];
                                    aWidthLines=_csw[k,2];

                                    coordinataTime1=_time[k,0];
                                    coordinataTime2=tf_mem;
                                    coordinataCena1=_cena[k,0];
                                    coordinataCena2=cena_mem;
                                    _cCenaAdd();
                                    typeObj="02";
                                    nameObj=prefics+typeObj+countLines+"0000000000000"+numTF+numTF+numTF+time_str(coordinataTime1)+cCenaAdd1+DoubleToStr(coordinataCena1,Digits)+time_str(coordinataTime2)+cCenaAdd2+DoubleToStr(coordinataCena2,Digits);

                                    Create_lines();
                                   }
                                }
                             }

                           point_mem=i;
                           cena_mem=cena0;
                           tf_mem=tf0;
                          }

                       }
                    }
                 }
              }
            else
              {
               if (point1==0) continue;

               tangens_mem=tangens;

               for (i=point_mem;i>=0;i--)
                 {
                  if (_type[k]==1) tangens_mem=(iHigh(Symbol(),mtf,i)-_cena[k,0])/(point1-i);
                  else if (_type[k]==2) tangens_mem=(_cena[k,0]-iLow(Symbol(),mtf,i))/(point1-i);  

                  if (tangens_mem>tangens0)
                    {
                     tangens0=tangens_mem;
                     tf0=iTime(Symbol(),mtf,i);

                     if (_type[k]==1) cena0=iHigh(Symbol(),mtf,i);
                     else if (_type[k]==2) cena0=iLow(Symbol(),mtf,i);

                     if (_pl[k,4]==9)
                       {
                        if (i<point_mem-missedBars)
                          {
                           counted_objects();

                           if (countLines!="***")
                             {
                              if (StrToInteger(countLines)==col+1) {col++; _arrayResize(col);}

                              aColorLines=_csw[k,0];
                              aStyleLines=_csw[k,1];
                              aWidthLines=_csw[k,2];

                              coordinataTime1=_time[k,0];
                              coordinataTime2=tf_mem;
                              coordinataCena1=_cena[k,0];
                              coordinataCena2=cena_mem;
                              _cCenaAdd();
                              typeObj=StringSubstr(_name[k],2,2);
                              nameObj=prefics+typeObj+countLines+"0000000000000"+numTF+numTF+numTF+time_str(coordinataTime1)+cCenaAdd1+DoubleToStr(coordinataCena1,Digits)+time_str(coordinataTime2)+cCenaAdd2+DoubleToStr(coordinataCena2,Digits);

                              Create_lines();
                             }
                          }
                       }
                    }
                 }            
              }

            if (tangens0>tangens && chartchange<=0)
              {
               //  
               _numTf[k,0]=_numTf[k,1];
               _numTf[k,2]=_numTf[k,1];
               _time[k,1]=tf0;
               _cena[k,1]=cena0;

               coordinataTime1=_time[k,0];
               coordinataTime2=_time[k,1];
               coordinataCena1=_cena[k,0];
               coordinataCena2=_cena[k,1];
               _cCenaAdd();
               aColorLines=_csw[k,0];
               aStyleLines=_csw[k,1];
               aWidthLines=_csw[k,2];

               nameObj=_name[k];
               txt=StringSubstr(nameObj,0,20)+_numTf[k,0]+_numTf[k,1]+_numTf[k,2]+time_str(coordinataTime1)+cCenaAdd1+DoubleToStr(coordinataCena1,Digits)+time_str(coordinataTime2)+cCenaAdd2+DoubleToStr(coordinataCena2,Digits);
               countLines=StringSubstr(txt,4,3);
               ObjectDelete(nameObj);
               nameObj=txt;
               Create_lines();
              }
           }
        }
     }
  }
//--------------------------------------------------------
//   . .
//--------------------------------------------------------

//--------------------------------------------------------
// c     . .
//--------------------------------------------------------
void _PriceLabelOnLines_1()
  {
   int k;

   for (k=0; k<col; k++)
     {
      nameObj=_name[k];
      if (_atl[k] && ObjectFind(nameObj)==0)
        {
         countLines=StringSubstr(nameObj,4,3);
         if (_type[k]>0 && _pl[k,2]>0) _PriceLabelOnLines();
        }
     }
  }
//--------------------------------------------------------
// c     . .
//--------------------------------------------------------

//--------------------------------------------------------
// c     . .
//--------------------------------------------------------
void _PriceLabelOnLines()
  {
   int i, k, point1, point2, mtf, aSizePLOL;
   string nameObj1="PLOL_"+countLines, nameObj2, nameObj3, cCenaPLOL;
   double tangens, cCenaPLOL1=ObjectGetValueByShift(nameObj,0);

   k=StrToInteger(countLines)-1;

   if (ObjectFind(nameObj1)>=0)
     {
      aSizePLOL=ObjectGet(nameObj1,OBJPROP_FONTSIZE);
     }
   else
     {
      aSizePLOL=SizeLevelLines;
     }
   
//   numTF0=StringSubstr(nameObj,20,1);  //  ,    .
   mtf=_tf[StrToInteger(StringSubstr(nameObj,20,1))];

   cTime1=ObjectGet(nameObj,OBJPROP_TIME1);
   cTime2=ObjectGet(nameObj,OBJPROP_TIME2);

   point1=iBarShift(Symbol(),Period(),cTime1,false);
   point2=iBarShift(Symbol(),Period(),cTime2,false);

   //      (   )
   ObjectDelete(nameObj1);

   if (point1<0 || point2<0) return;
   if (point1==point2) {ObjectDelete(nameObj1); return;}

   aColorLines=_csw[k,0];

   if (_pl[k,2]>0)
     {
      ObjectCreate(nameObj1,OBJ_TEXT,0,iTime(Symbol(),mtf,0),cCenaPLOL1);
      ObjectSet(nameObj1, OBJPROP_COLOR,aColorLines);
     }
   else return;

   cCena1=ObjectGet(nameObj,OBJPROP_PRICE1);
   cCena2=ObjectGet(nameObj,OBJPROP_PRICE2);

   point1=iBarShift(Symbol(),mtf,cTime1,false);
   point2=iBarShift(Symbol(),mtf,cTime2,false);

   if (point1<0 || point2<0) return;
   if (point1==point2) return;

   tangens=(cCena2-cCena1)/(point1-point2);

   cCenaPLOL=DoubleToStr(cCena2+point2*tangens,Digits);

   if (_pl[k,2]==1 || _pl[k,2]==3)
     {
      ObjectSetText(nameObj1,cCenaPLOL,aSizePLOL,"Arial", _csw[k,0]);
     }
   else if (_pl[k,2]==2 || _pl[k,2]==4)
     {
      ObjectSetText(nameObj1,DoubleToStr(cCenaPLOL1,Digits),aSizePLOL,"Arial", _csw[k,0]);
     }

   if (_pl[k,2]==3 || _pl[k,2]==4)
     {
      // Reaction1  Reaction2
      if (_pl[k,0]==1 || _pl[k,0]==4)
        {
         nameObj2="Reaction1_"+countLines;
         nameObj3=nameObj1+"R1";
         cCenaPLOL1=ObjectGetValueByShift(nameObj2,0);
         ObjectDelete(nameObj3);
         ObjectCreate(nameObj3,OBJ_TEXT,0,iTime(Symbol(),mtf,0),cCenaPLOL1);
         if (_pl[k,2]==3)
           {
            cCenaPLOL=DoubleToStr(cCena2+point2*tangens+_h1[k,0],Digits);
            ObjectSetText(nameObj3,cCenaPLOL,aSizePLOL,"Arial", _csw[k,0]);
           }
         else if (_pl[k,2]==4)
           {
            ObjectSetText(nameObj3,DoubleToStr(cCenaPLOL1,Digits),aSizePLOL,"Arial", _csw[k,0]);
           }

         ObjectSet(nameObj3, OBJPROP_COLOR,aColorLines);

         nameObj2="Reaction2_"+countLines;
         if (ObjectFind(nameObj2)==0)
           {
            nameObj3=nameObj1+"R2";
            cCenaPLOL1=ObjectGetValueByShift(nameObj2,0);
            ObjectDelete(nameObj3);
            ObjectCreate(nameObj3,OBJ_TEXT,0,iTime(Symbol(),mtf,0),cCenaPLOL1);
            if (_pl[k,2]==3)
              {
               cCenaPLOL=DoubleToStr(cCena2+point2*tangens+_h1[k,1],Digits);
               ObjectSetText(nameObj3,cCenaPLOL,aSizePLOL,"Arial", _csw[k,0]);
              }
            else if (_pl[k,2]==4)
              {
               ObjectSetText(nameObj3,DoubleToStr(cCenaPLOL1,Digits),aSizePLOL,"Arial", _csw[k,0]);
              }

            ObjectSet(nameObj3, OBJPROP_COLOR,aColorLines);
           }
        }

      // Action1  Action2
      if (_pl[k,0]>3)
        {
         nameObj2="Action1_"+countLines;
         if (ObjectFind(nameObj2)==0)
           {
            nameObj3=nameObj1+"A1";
            cCenaPLOL1=ObjectGetValueByShift(nameObj2,0);
            ObjectDelete(nameObj3);
            ObjectCreate(nameObj3,OBJ_TEXT,0,iTime(Symbol(),mtf,0),cCenaPLOL1);
            if (_pl[k,2]==3)
              {
               cCenaPLOL=DoubleToStr(cCena2+point2*tangens-_h1[k,0],Digits);
               ObjectSetText(nameObj3,cCenaPLOL,aSizePLOL,"Arial", _csw[k,0]);
              }
            else if (_pl[k,2]==4)
              {
               ObjectSetText(nameObj3,DoubleToStr(cCenaPLOL1,Digits),aSizePLOL,"Arial", _csw[k,0]);
              }

            ObjectSet(nameObj3, OBJPROP_COLOR,aColorLines);
           }

         nameObj2="Action2_"+countLines;
         if (ObjectFind(nameObj2)==0)
           {
            nameObj3=nameObj1+"A2";
            cCenaPLOL1=ObjectGetValueByShift(nameObj2,0);
            ObjectDelete(nameObj3);
            ObjectCreate(nameObj3,OBJ_TEXT,0,iTime(Symbol(),mtf,0),cCenaPLOL1);
            if (_pl[k,2]==3)
              {
               cCenaPLOL=DoubleToStr(cCena2+point2*tangens-_h1[k,1],Digits);
               ObjectSetText(nameObj3,cCenaPLOL,aSizePLOL,"Arial", _csw[k,0]);
              }
            else if (_pl[k,2]==4)
              {
               ObjectSetText(nameObj3,DoubleToStr(cCenaPLOL1,Digits),aSizePLOL,"Arial", _csw[k,0]);
              }

            ObjectSet(nameObj3, OBJPROP_COLOR,aColorLines);
           }
        }

      //  Reaction1
      if (_pl[k,0]==2 || _pl[k,0]==5 || _pl[k,0]==7 || _pl[k,0]==9)
        {
         for (i=0; true; i++)
           {
            nameObj2="Reaction1_"+countLines+i;
            if (ObjectFind(nameObj2)==0)
              {
               nameObj3=nameObj1+"R1"+i;
               cCenaPLOL1=ObjectGetValueByShift(nameObj2,0);
               ObjectDelete(nameObj3);
               ObjectCreate(nameObj3,OBJ_TEXT,0,iTime(Symbol(),mtf,0),cCenaPLOL1);
               if (_pl[k,2]==3)
                 {
                  if (_pl[k,0]==9)
                    {
                     cCenaPLOL=DoubleToStr(cCena2+point2*tangens-_h1[k,0]-_h1[k,0]*StrToDouble(ObjectDescription(nameObj2))/100,Digits);
                    }
                  else
                    {
                     cCenaPLOL=DoubleToStr(cCena2+point2*tangens+_h1[k,0]*StrToDouble(ObjectDescription(nameObj2))/100,Digits);
                    }
                  ObjectSetText(nameObj3,cCenaPLOL,aSizePLOL,"Arial", _csw[k,0]);
                 }
               else if (_pl[k,2]==4)
                 {
                  ObjectSetText(nameObj3,DoubleToStr(cCenaPLOL1,Digits),aSizePLOL,"Arial", _csw[k,0]);
                 }

               ObjectSet(nameObj3, OBJPROP_COLOR,aColorLines);
              }
            else break;
           }
        }

      //  Reaction2
      if (_pl[k,0]==3 || _pl[k,0]==6 || _pl[k,0]==8)
        {
         for (i=0; true; i++)
           {
            nameObj2="Reaction2_"+countLines+i;
            if (ObjectFind(nameObj2)==0)
              {
               nameObj3=nameObj1+"R2"+i;
               cCenaPLOL1=ObjectGetValueByShift(nameObj2,0);
               ObjectDelete(nameObj3);
               ObjectCreate(nameObj3,OBJ_TEXT,0,iTime(Symbol(),mtf,0),cCenaPLOL1);
               if (_pl[k,2]==3)
                 {
                  cCenaPLOL=DoubleToStr(cCena2+point2*tangens+_h1[k,1]*StrToDouble(ObjectDescription(nameObj2))/100,Digits);
                  ObjectSetText(nameObj3,cCenaPLOL,aSizePLOL,"Arial", _csw[k,0]);
                 }
               else if (_pl[k,2]==4)
                 {
                  ObjectSetText(nameObj3,DoubleToStr(cCenaPLOL1,Digits),aSizePLOL,"Arial", _csw[k,0]);
                 }

               ObjectSet(nameObj3, OBJPROP_COLOR,aColorLines);
              }
            else break;
           }
        }
     }
  }
//--------------------------------------------------------
// c     . .
//--------------------------------------------------------

//--------------------------------------------------------
//   . .
//--------------------------------------------------------
void _reaction()
  {
   int i, j, k, point1, point2, mtf;
   int aColorReactionLines, aStyleReactionLines, aWidthReactionLines, aColorReactionLines2, aStyleReactionLines2, aWidthReactionLines2;
   int aColorActionLines, aStyleActionLines, aWidthActionLines, aColorActionLines2, aStyleActionLines2, aWidthActionLines2;
   int aColorLevelLines, aSizeLevelLines;
   double h1=0, h2=0, wr=0, tangens;
   string nameObj1,nameObj2,nameObj3,nameObj4,nameObj5,nameObj6,txt;
   bool  fl=false; //     Action2

   for (k=0;k<col;k++)
     {
      if (!_atl[k]) continue;
      if (ObjectFind(_name[k])<0)
        {
         _atl[k]=false; 
         _delete_obj(k);
         continue;
        }

      if (_pl[k,0]>0)
        {
         _h1[k,0]=0;
         _h1[k,1]=0;


//   numTF0=StringSubstr(nameObj,20,1);  //  ,    .
         mtf=_tf[StrToInteger(StringSubstr(nameObj,20,1))];

         cTime1=ObjectGet(nameObj,OBJPROP_TIME1);
         cTime2=ObjectGet(nameObj,OBJPROP_TIME2);
         cCena1=ObjectGet(nameObj,OBJPROP_PRICE1);
         cCena2=ObjectGet(nameObj,OBJPROP_PRICE2);

         point1=iBarShift(Symbol(),mtf,cTime1,false);
         point2=iBarShift(Symbol(),mtf,cTime2,false);

         nameObj1="Reaction1_"+countLines;
         nameObj2="Reaction2_"+countLines;
         nameObj3="Action1_"+countLines;
         nameObj4="Action2_"+countLines;
         nameObj5="Level_"+countLines;
         nameObj6="nAct_"+countLines;

         i=number_Obj(nameObj1);
         if (i>0)
           {
            if (AllObjectsOfOneColor) aColorReactionLines=aColorLines; else aColorReactionLines=ObjectGet(ObjectName(i),OBJPROP_COLOR);
            aStyleReactionLines=ObjectGet(ObjectName(i),OBJPROP_STYLE);
            aWidthReactionLines=ObjectGet(ObjectName(i),OBJPROP_WIDTH);
           }
         else
           {
            if (AllObjectsOfOneColor) aColorReactionLines=aColorLines; else aColorReactionLines=ColorReactionLines;
            aStyleReactionLines=StyleReactionLines;
            aWidthReactionLines=WidthReactionLines;
           }

         i=number_Obj(nameObj2);
         if (i>0)
           {
            if (AllObjectsOfOneColor) aColorReactionLines2=aColorLines; else aColorReactionLines2=ObjectGet(ObjectName(i),OBJPROP_COLOR);
            aStyleReactionLines2=ObjectGet(ObjectName(i),OBJPROP_STYLE);
            aWidthReactionLines2=ObjectGet(ObjectName(i),OBJPROP_WIDTH);
           }
         else
           {
            if (AllObjectsOfOneColor) aColorReactionLines2=aColorLines; else aColorReactionLines2=ColorReactionLines;
            aStyleReactionLines2=StyleReactionLines;
            aWidthReactionLines2=WidthReactionLines;
           }

         i=number_Obj(nameObj3);
         if (i>0)
           {
            if (AllObjectsOfOneColor) aColorActionLines=aColorLines; else aColorActionLines=ObjectGet(ObjectName(i),OBJPROP_COLOR);
            aStyleActionLines=ObjectGet(ObjectName(i),OBJPROP_STYLE);
            aWidthActionLines=ObjectGet(ObjectName(i),OBJPROP_WIDTH);
           }
         else
           {
            if (AllObjectsOfOneColor) aColorActionLines=aColorLines; else aColorActionLines=ColorActionLines;
            aStyleActionLines=StyleReactionLines;
            aWidthActionLines=WidthReactionLines;
           }

         i=number_Obj(nameObj4);
         if (i>0)
           {
            if (AllObjectsOfOneColor) aColorActionLines2=aColorLines; else aColorActionLines2=ObjectGet(ObjectName(i),OBJPROP_COLOR);
            aStyleActionLines2=ObjectGet(ObjectName(i),OBJPROP_STYLE);
            aWidthActionLines2=ObjectGet(ObjectName(i),OBJPROP_WIDTH);
           }
         else
           {
            if (AllObjectsOfOneColor) aColorActionLines2=aColorLines; else aColorActionLines2=ColorActionLines;
            aStyleActionLines2=StyleReactionLines;
            aWidthActionLines2=WidthReactionLines;
           }

         i=number_Obj(nameObj5);
         if (i>0)
           {
            if (AllObjectsOfOneColor) aColorLevelLines=aColorLines; else aColorLevelLines=ObjectGet(ObjectName(i),OBJPROP_COLOR);
            aSizeLevelLines=ObjectGet(ObjectName(i),OBJPROP_FONTSIZE);
           }
         else
           {
            if (AllObjectsOfOneColor) aColorLevelLines=aColorLines; else aColorLevelLines=ColorLevelLines;
            aSizeLevelLines=SizeLevelLines;
           }
         delete_a_reaction();

         if (point1<0 || point2<0) return;
         if (point1==point2 || _pl[k,0]==0) return;

         tangens=(cCena2-cCena1)/(point1-point2);
   
         if (typeObj=="01")
           {
            for(i=point1;i>=point2;i--)
              {
               wr=(cCena1+tangens*(point1-i))-iLow(Symbol(),mtf,i);
               if (wr>h1) h1=wr;
              }

            _h1[k,0]=h1;

            wr=0; j=0;
            for(i=point2;i>0;i--)
              {
               wr=cCena2+tangens*(point2-i)-iLow(Symbol(),mtf,i);
               if (wr>h2) {h2=wr;j=i;}
               if (wr<0) {fl=true; break;}
              }

            _h1[k,1]=h2;
            }
          else if (typeObj=="02")
            {
             for(i=point1;i>=point2;i--)
               {
                wr=(cCena1+tangens*(point1-i))-iHigh(Symbol(),mtf,i);
                if (wr<h1) h1=wr;
               }

             _h1[k,0]=h1;

             wr=0; j=0;
             for(i=point2;i>0;i--)
               {
                wr=(cCena2+tangens*(point2-i))-iHigh(Symbol(),mtf,i);
                if (wr<h2) {h2=wr;j=i;}
                if (wr>0) {fl=true; break;}
               }

             _h1[k,1]=h2;
            }

          // Reaction1
          if (_pl[k,0]==1 || _pl[k,0]==4)
            {
             ObjectCreate(nameObj1,OBJ_TREND,0,cTime1,cCena1+h1,cTime2,cCena2+h1);
             ObjectSetText(nameObj1, countLines);
             ObjectSet(nameObj1, OBJPROP_COLOR, aColorReactionLines);
             ObjectSet(nameObj1,OBJPROP_STYLE, aStyleReactionLines);
             ObjectSet(nameObj1,OBJPROP_WIDTH, aWidthReactionLines);

             ObjectCreate(nameObj6+3,OBJ_TEXT,0,cTime1,cCena1+h1);
             ObjectSetText(nameObj6+3,"R1",aSizeLevelLines,"Arial", aColorLevelLines);
       
            // (Reaction2)
             if (fl && j>0)
               {
                ObjectCreate(nameObj2,OBJ_TREND,0,cTime1,cCena1+h2,cTime2,cCena2+h2);
                ObjectSetText(nameObj2, countLines);
                ObjectSet(nameObj2, OBJPROP_COLOR, aColorReactionLines2);
                ObjectSet(nameObj2,OBJPROP_STYLE, aStyleReactionLines2);
                ObjectSet(nameObj2,OBJPROP_WIDTH, aWidthReactionLines2);

                ObjectCreate(nameObj6+4,OBJ_TEXT,0,cTime1,cCena1+h2);
                ObjectSetText(nameObj6+4,"R2",aSizeLevelLines,"Arial", aColorLevelLines);
               }
            }
          else if (_pl[k,0]==2 || _pl[k,0]==5 || _pl[k,0]==7)
            {
             for (i=0;i<Sizefi;i++)
               {
                nameObj1="Reaction1_"+countLines+i;
                ObjectCreate(nameObj1,OBJ_TREND,0,cTime1,cCena1+h1*fi[i],cTime2,cCena2+h1*fi[i]);
                ObjectSet(nameObj1, OBJPROP_COLOR, aColorReactionLines);
                ObjectSet(nameObj1,OBJPROP_STYLE, aStyleReactionLines);
                ObjectSet(nameObj1,OBJPROP_WIDTH, aWidthReactionLines);
                ObjectSetText(nameObj1,fitxt100[i],aSizeLevelLines,"Arial", aColorLevelLines);
                if (_pl[k,0]==7)
                  {
                   nameObj5="Level_"+countLines+i;
                   ObjectCreate(nameObj5,OBJ_TEXT,0,cTime1,cCena1+h1*fi[i]);
                   ObjectSetText(nameObj5,fitxt100[i],aSizeLevelLines,"Arial", aColorLevelLines);
                  }
               }
            }
          else if (_pl[k,0]==9)
            {
             for (i=0;i<Sizefi;i++)
               {
                nameObj1="Reaction1_"+countLines+i;
                ObjectCreate(nameObj1,OBJ_TREND,0,cTime1,cCena1-h1-h1*fi[i],cTime2,cCena2-h1-h1*fi[i]);
                ObjectSet(nameObj1, OBJPROP_COLOR, aColorReactionLines);
                ObjectSet(nameObj1,OBJPROP_STYLE, aStyleReactionLines);
                ObjectSet(nameObj1,OBJPROP_WIDTH, aWidthReactionLines);
                ObjectSetText(nameObj1,fitxt100[i],aSizeLevelLines,"Arial", aColorLevelLines);

                nameObj5="Level_"+countLines+i;
                ObjectCreate(nameObj5,OBJ_TEXT,0,cTime1,cCena1-h1-h1*fi[i]);
                ObjectSetText(nameObj5,fitxt100[i],aSizeLevelLines,"Arial", aColorLevelLines);
               }
            }

          // Reaction2
          if ((_pl[k,0]==3 || _pl[k,0]==6 || _pl[k,0]==8) && fl && j>0)
            {
             for (i=0;i<Sizefi;i++)
               {
                nameObj2="Reaction2_"+countLines+i;
                ObjectCreate(nameObj2,OBJ_TREND,0,cTime1,cCena1+h2*fi[i],cTime2,cCena2+h2*fi[i]);
                ObjectSet(nameObj2, OBJPROP_COLOR, aColorReactionLines);
                ObjectSet(nameObj2,OBJPROP_STYLE, aStyleReactionLines);
                ObjectSet(nameObj2,OBJPROP_WIDTH, aWidthReactionLines);
                ObjectSetText(nameObj2,fitxt100[i],aSizeLevelLines,"Arial", aColorLevelLines);
                if (_pl[k,0]==8)
                  {
                   nameObj5="Level_"+countLines+i;
                   ObjectCreate(nameObj5,OBJ_TEXT,0,cTime1,cCena1+h2*fi[i]);
                   ObjectSetText(nameObj5,fitxt100[i],aSizeLevelLines,"Arial", aColorLevelLines);
                  }
               }
            }

          // Action1
          if (_pl[k,0]==4 || _pl[k,0]==5 || _pl[k,0]==7 || _pl[k,0]==9 || _pl[k,0]==10)
            {
             ObjectCreate(nameObj3,OBJ_TREND,0,cTime1,cCena1-h1,cTime2,cCena2-h1);
             ObjectSetText(nameObj3, countLines);
             ObjectSet(nameObj3, OBJPROP_COLOR, aColorActionLines);
             ObjectSet(nameObj3,OBJPROP_STYLE, aStyleActionLines);
             ObjectSet(nameObj3,OBJPROP_WIDTH, aWidthActionLines);

             ObjectCreate(nameObj6+1,OBJ_TEXT,0,cTime1,cCena1-h1);
             ObjectSetText(nameObj6+1,"A1",aSizeLevelLines,"Arial", aColorLevelLines);
            }

          // Action2
          if ((_pl[k,0]==4 || _pl[k,0]==6 || _pl[k,0]==8) && fl && j>0)
            {
             ObjectCreate(nameObj4,OBJ_TREND,0,cTime1,cCena1-h2,cTime2,cCena2-h2);
             ObjectSetText(nameObj4, countLines);
             ObjectSet(nameObj4, OBJPROP_COLOR, aColorActionLines2);
             ObjectSet(nameObj4,OBJPROP_STYLE, aStyleActionLines2);
             ObjectSet(nameObj4,OBJPROP_WIDTH, aWidthActionLines2);

             ObjectCreate(nameObj6+2,OBJ_TEXT,0,cTime1,cCena1-h2);
             ObjectSetText(nameObj6+2,"A2",aSizeLevelLines,"Arial", aColorLevelLines);
            }
       }
    }
  }
//--------------------------------------------------------
//   . .
//--------------------------------------------------------

//--------------------------------------------------------
// -Time. .
//--------------------------------------------------------
void _fiboTimeMulty()
  {
   double  h1=0, h2=0, wr=0, wr2=0, tangens, ch1, ch2;
   int    ih1=0, ih2=0;
   int    i, k, point1, point2, mtf;
   string nameObj1,nameObj2,nameObj3,nameObj4;
   int    aColorft1, aColorft2, aColorft3, aColorft4;
   int    aStyleft1, aStyleft2, aStyleft3, aStyleft4;
   int    aWidthft1, aWidthft2, aWidthft3, aWidthft4;

   k=StrToInteger(countLines)-1;
   mtf=_tf[StrToInteger(StringSubstr(nameObj,20,1))];

   cTime1=ObjectGet(nameObj,OBJPROP_TIME1);
   cTime2=ObjectGet(nameObj,OBJPROP_TIME2);
   cCena1=ObjectGet(nameObj,OBJPROP_PRICE1);
   cCena2=ObjectGet(nameObj,OBJPROP_PRICE2);

   point1=iBarShift(Symbol(),mtf,cTime1,false);
   point2=iBarShift(Symbol(),mtf,cTime2,false);

   nameObj1="ft1_"+countLines;
   nameObj2="ft2_"+countLines;
   nameObj3="ft3_"+countLines;
   nameObj4="ft4_"+countLines;

   if (ObjectFind(nameObj1)==0)
     {
      aColorft1=ObjectGet(nameObj1,OBJPROP_LEVELCOLOR);
      aStyleft1=ObjectGet(nameObj1,OBJPROP_LEVELSTYLE);
      aWidthft1=ObjectGet(nameObj1,OBJPROP_LEVELWIDTH);
      ObjectDelete(nameObj1);
     }
   else
     {
      aColorft1=ColorList[0];
      aStyleft1=StyleFiboTime;
      aWidthft1=WidthFiboTime;
     }

   if (ObjectFind(nameObj2)==0)
     {
      aColorft2=ObjectGet(nameObj2,OBJPROP_LEVELCOLOR);
      aStyleft2=ObjectGet(nameObj2,OBJPROP_LEVELSTYLE);
      aWidthft2=ObjectGet(nameObj2,OBJPROP_LEVELWIDTH);
      ObjectDelete(nameObj2);
     }
   else
     {
      aColorft2=ColorList[1];
      aStyleft2=StyleFiboTime;
      aWidthft2=WidthFiboTime;
     }

   if (ObjectFind(nameObj3)==0)
     {
      aColorft3=ObjectGet(nameObj3,OBJPROP_LEVELCOLOR);
      aStyleft3=ObjectGet(nameObj3,OBJPROP_LEVELSTYLE);
      aWidthft3=ObjectGet(nameObj3,OBJPROP_LEVELWIDTH);
      ObjectDelete(nameObj3);
     }
   else
     {
      aColorft3=ColorList[2];
      aStyleft3=StyleFiboTime;
      aWidthft3=WidthFiboTime;
     }

   if (ObjectFind(nameObj4)==0)
     {
      aColorft4=ObjectGet(nameObj4,OBJPROP_LEVELCOLOR);
      aStyleft4=ObjectGet(nameObj4,OBJPROP_LEVELSTYLE);
      aWidthft4=ObjectGet(nameObj4,OBJPROP_LEVELWIDTH);
      ObjectDelete(nameObj4);
     }
   else
     {
      aColorft4=ColorList[3];
      aStyleft4=StyleFiboTime;
      aWidthft4=WidthFiboTime;
     }

   if (point1<0 || point2<0) return;
   if (point1==point2) return;

   tangens=(cCena2-cCena1)/(point1-point2);

   if (_pl[k,1]>0)
     {
      if (typeObj=="01")
        {
         if (_pl[k,1]==1)
           {
            for(i=point1;i>=point2;i--)
              {
               wr=(cCena1+tangens*(point1-i))-iLow(Symbol(),mtf,i);
               if (wr>h1) {h1=wr; ih1=i;}
              }

            wr2=0; h2=0;
            for(i=point2;i>0;i--)
              {
               wr2=cCena2+tangens*(point2-i)-iLow(Symbol(),mtf,i);
               if (wr2>h2) {h2=wr2;ih2=i;}
               if (wr2<0) break; 
              }
           }
         else
           {
            ih1=search_Low(mtf,point1,point2);
            h1=(cCena1+tangens*(point1-ih1))-iLow(Symbol(),mtf,ih1);

            wr2=0; ih2=0;
            for(i=point2;i>0;i--)
              {
               wr2=cCena2+tangens*(point2-i)-iLow(Symbol(),mtf,i);
               if (wr2<0) {ih2=search_Low(mtf,point2,i); h2=cCena2+tangens*(point2-ih2)-iLow(Symbol(),mtf,ih2); break;}
              }
           }

         ch1=-h1*2/3;
         ch2=-h2;
        }
      else if (typeObj=="02")
        {
         if (_pl[k,1]==1)
           {
            for(i=point1;i>=point2;i--)
              {
               wr=iHigh(Symbol(),mtf,i)-(cCena1+tangens*(point1-i));
               if (wr>h1) {h1=wr; ih1=i;}
              }

            wr2=0; h2=0;
            for(i=point2;i>0;i--)
              {
               wr2=iHigh(Symbol(),mtf,i)-(cCena2+tangens*(point2-i));
               if (wr2>h2) {h2=wr2;ih2=i;}
               if (wr2<0) break; 
              }
           }
         else
           {
            ih1=search_High(mtf,point1,point2);
            h1=iHigh(Symbol(),mtf,ih1)-(cCena1+tangens*(point1-ih1));

            wr2=0; ih2=0;
            for(i=point2;i>0;i--)
              {
               wr2=iHigh(Symbol(),mtf,i)-(cCena2+tangens*(point2-i));
               if (wr2<0) {ih2=search_High(mtf,point2,i); h2=iHigh(Symbol(),mtf,ih2)-(cCena2+tangens*(point2-ih2)); break;}
              }
           }

         ch1=h1*2/3;
         ch1=h2;
        }

      ObjectCreate(nameObj1,OBJ_FIBOTIMES,0,cTime1,cCena1,cTime2,cCena1);
      ObjectSet(nameObj1,OBJPROP_COLOR,CLR_NONE);

      if (_pl[k,1]!=3)
        {
         ObjectSet(nameObj1,OBJPROP_LEVELCOLOR,aColorft1);
         ObjectSet(nameObj1,OBJPROP_LEVELSTYLE,aStyleft1);
         ObjectSet(nameObj1,OBJPROP_LEVELWIDTH,aWidthft1);
         ObjectSet(nameObj1,OBJPROP_FIBOLEVELS, ftSize);

         ObjectCreate(nameObj2,OBJ_FIBOTIMES,0,cTime1,cCena1+ch1,iTime(Symbol(),mtf,ih1),cCena1+ch1);
         ObjectSet(nameObj2,OBJPROP_COLOR,CLR_NONE);
         ObjectSet(nameObj2,OBJPROP_LEVELCOLOR,aColorft2);
         ObjectSet(nameObj2,OBJPROP_LEVELSTYLE,aStyleft2);
         ObjectSet(nameObj2,OBJPROP_LEVELWIDTH,aWidthft2);
         ObjectSet(nameObj2,OBJPROP_FIBOLEVELS, ftSize);

         ObjectCreate(nameObj3,OBJ_FIBOTIMES,0,iTime(Symbol(),mtf,ih1),cCena1+ch1/2,cTime2,cCena1+ch1/2);
         ObjectSet(nameObj3,OBJPROP_COLOR,CLR_NONE);
         ObjectSet(nameObj3,OBJPROP_LEVELCOLOR,aColorft2);
         ObjectSet(nameObj3,OBJPROP_LEVELSTYLE,aStyleft2);
         ObjectSet(nameObj3,OBJPROP_LEVELWIDTH,aWidthft2);
         ObjectSet(nameObj3,OBJPROP_FIBOLEVELS, ftSize);

         if (wr2<0)
           {
            ObjectCreate(nameObj4,OBJ_FIBOTIMES,0,iTime(Symbol(),mtf,ih1),cCena2+ch2,iTime(Symbol(),mtf,ih2),cCena2+ch2);
            ObjectSet(nameObj4,OBJPROP_COLOR,CLR_NONE);
            ObjectSet(nameObj4,OBJPROP_LEVELCOLOR,aColorft2);
            ObjectSet(nameObj4,OBJPROP_LEVELSTYLE,aStyleft2);
            ObjectSet(nameObj4,OBJPROP_LEVELWIDTH,aWidthft2);
            ObjectSet(nameObj4,OBJPROP_FIBOLEVELS, ftSize);
           }

         i=0;
         for (i=0;i<ftSize;i++)
           {
            ObjectSet(nameObj1,OBJPROP_FIRSTLEVEL+i,1+ft[i]);
            ObjectSetFiboDescription(nameObj1, i, fttxt[i]);

            ObjectSet(nameObj2,OBJPROP_FIRSTLEVEL+i,1+ft[i]);
            ObjectSetFiboDescription(nameObj2, i, fttxt[i]);

            ObjectSet(nameObj3,OBJPROP_FIRSTLEVEL+i,1+ft[i]);
            ObjectSetFiboDescription(nameObj3, i, fttxt[i]);

            if (wr2<0)
              {
               ObjectSet(nameObj4,OBJPROP_FIRSTLEVEL+i,1+ft[i]);
               ObjectSetFiboDescription(nameObj4, i, fttxt[i]);
              }
           }
        }
      else if (QuantityCycles>0)
        {
         ObjectSet(nameObj1,OBJPROP_LEVELCOLOR,aColorLines);
         ObjectSet(nameObj1,OBJPROP_LEVELSTYLE,aStyleLines);
         ObjectSet(nameObj1,OBJPROP_LEVELWIDTH,aWidthLines);
         ObjectSet(nameObj1,OBJPROP_FIBOLEVELS,QuantityCycles+1);

         i=0;
         for (i=0;i<=QuantityCycles;i++)
           {
            ObjectSet(nameObj1,OBJPROP_FIRSTLEVEL+i,i);
            if (i>0) ObjectSetFiboDescription(nameObj1, i, ""+i);
           }
        }
     }
  }
//--------------------------------------------------------
// -Time. .
//--------------------------------------------------------

//--------------------------------------------------------
//  . .
//   false -   
//             true -  
//--------------------------------------------------------
bool search_bar(int tf)
  {
   datetime t1=cTime1,t2=cTime2;
   int cc1,cc2,co1,co2;
   cc1=MathRound(cCena1/Point);
   cc2=MathRound(cCena2/Point);
   int j=iBarShift(Symbol(),tf,cTime1,false), k=iBarShift(Symbol(),tf,cTime2,false);

   //  High
   co1=MathRound(iHigh(Symbol(),tf,j)/Point);
   co2=MathRound(iHigh(Symbol(),tf,k)/Point);

   if ((co1==cc1 && co2==cc2) || (TransformationMax && typeObj=="01"))
     {
      if (TransformationMax)
        {
         t1=cTime1;
         coordinataCena1=search_high_Max(tf, cTime1);
        }
      else
        {
         t1=search_high(tf, cTime1, cCena1);
        }

      if (newBar)
        {
         if (TransformationMax)
           {
            t2=cTime2;
            coordinataCena2=search_high_Max(tf, cTime2);
           }
         else
           {
            t2=search_high(tf, cTime2, cCena2);
           }

         if (newBar)
           {
            if (t1!=t2)
              {
               numTF0=numTF;
               coordinataTime1=t1;
               coordinataTime2=t2;
              }
            else
              {
               newBar=false; return(false);
              }
           }
        }
      typeObj="01"; 
      return(true);
     }

   //  Low
   co1=MathRound(iLow(Symbol(),tf,j)/Point);
   co2=MathRound(iLow(Symbol(),tf,k)/Point);
   if ((co1==cc1 && co2==cc2) || (TransformationMax && typeObj=="02"))
     {
      if (TransformationMax)
        {
         t1=cTime1;
         coordinataCena1=search_low_Max(tf, cTime1);
        }
      else
        {
         t1=search_low(tf, cTime1, cCena1);
        }

      if (newBar)
        {

         if (TransformationMax)
           {
            t2=cTime2;
            coordinataCena2=search_low_Max(tf, cTime2);
           }
         else
           {
            t2=search_low(tf, cTime2, cCena2);
           }

         if (newBar)
           {
            if (t1!=t2)
              {
               numTF0=numTF;
               coordinataTime1=t1;
               coordinataTime2=t2;
              }
            else
              {
               newBar=false; return(false);
              }
           }
        }
      typeObj="02"; 
      return(true);
     }

   //  High-Low
   co1=MathRound(iHigh(Symbol(),tf,j)/Point);
   co2=MathRound(iLow(Symbol(),tf,k)/Point);
   if ((co1==cc1 && co2==cc2) || (TransformationMax && typeObj=="03"))
     {
      if (TransformationMax)
        {
         t1=cTime1;
         coordinataCena1=search_high_Max(tf, cTime1);
        }
      else
        {
         t1=search_high(tf, cTime1, cCena1);
        }

      if (newBar)
        {
         if (TransformationMax)
           {
            t2=cTime2;
            coordinataCena2=search_low_Max(tf, cTime2);
           }
         else
           {
            t2=search_low(tf, cTime2, cCena2);
           }

         if (newBar)
           {
            if (t1!=t2)
              {
               numTF0=numTF;
               coordinataTime1=t1;
               coordinataTime2=t2;
              }
            else
              {
               newBar=false; return(false);
              }
           }
        }
      typeObj="03"; 
      return(true);
     }

   //  Low-High
   co1=MathRound(iLow(Symbol(),tf,j)/Point);
   co2=MathRound(iHigh(Symbol(),tf,k)/Point);
   if ((co1==cc1 && co2==cc2) || (TransformationMax && typeObj=="04"))
     {
      if (TransformationMax)
        {
         t1=cTime1;
         coordinataCena1=search_low_Max(tf, cTime1);
        }
      else
        {
         t1=search_low(tf, cTime1, cCena1);
        }

      if (newBar)
        {
         if (TransformationMax)
           {
            t2=cTime2;
            coordinataCena2=search_high_Max(tf, cTime2);
           }
         else
           {
            t2=search_high(tf, cTime2, cCena2);
           }

         if (newBar)
           {
            if (t1!=t2)
              {
               numTF0=numTF;
               coordinataTime1=t1;
               coordinataTime2=t2;
              }
            else
              {
               newBar=false; return(false);
              }
           }
        }
      typeObj="04"; 
      return(true);
     }

   //  Close-Close
   co1=MathRound(iClose(Symbol(),tf,j)/Point);
   co2=MathRound(iClose(Symbol(),tf,k)/Point);
   if ((co1==cc1 && co2==cc2) || (TransformationMax && typeObj=="05"))
     {
      if (TransformationMax)
        {
         t1=cTime1;
         coordinataCena1=search_close_Max(tf, cTime1);
        }
      else
        {
         t1=search_close(tf, cTime1, cCena1);
        }

      if (newBar)
        {
         if (TransformationMax)
           {
            t2=cTime1;
            coordinataCena2=search_close_Max(tf, cTime2);
           }
         else
           {
            t2=search_close(tf, cTime2, cCena2);
           }

         if (newBar)
           {
            if (t1!=t2)
              {
               numTF0=numTF;
               coordinataTime1=t1;
               coordinataTime2=t2;
              }
            else
              {
               newBar=false; return(false);
              }
           }
        }
      typeObj="05"; 
      return(true);
     }
 
   if (typeObj!="06") {typeObj="00";}

   return(false);
  }
//--------------------------------------------------------
//  . .
//--------------------------------------------------------

//--------------------------------------------------------
//  . .
//      
//--------------------------------------------------------
double search_high_Max(int tf, datetime t)
  {
   newBar=true;
   return (iHigh(Symbol(),tf,iBarShift(Symbol(),tf,t,false)));
  }
//--------------------------------------------------------
//  . .
//      
//--------------------------------------------------------

//--------------------------------------------------------
//  . .
//      
//--------------------------------------------------------
double search_close_Max(int tf, datetime t)
  {
   newBar=true;
   return (iClose(Symbol(),tf,iBarShift(Symbol(),tf,t,false)));
  }
//--------------------------------------------------------
//  . .
//      
//--------------------------------------------------------

//--------------------------------------------------------
//  . .
//      
//--------------------------------------------------------
double search_low_Max(int tf, datetime t)
  {
   newBar=true;
   return (iLow(Symbol(),tf,iBarShift(Symbol(),tf,t,false)));
  }
//--------------------------------------------------------
//  . .
//      
//--------------------------------------------------------

//--------------------------------------------------------
//  . .
//    
//      newBar=false -   
//             true -  
//--------------------------------------------------------
datetime search_high(int tf, datetime t, double c)
  {
   int j=0,k=0, i, n=-1, mtf;
   // j -      ()
   // k -     
   double c1;
   bool w=false;
   newBar=false; 

   if (Transformation)
     {
      if (numTF>numTF0) mtf=_tf[StrToInteger(numTF0)]; else mtf=Period();
     }
   else
     {
      mtf=Period();
     }

   if (t==iTime(Symbol(),mtf,0)) j=0; else j=iBarShift(Symbol(),mtf,t,false);
   if (t==iTime(Symbol(),tf,0)) k=0; else k=iBarShift(Symbol(),tf,t,false);
   datetime t2, tm=iTime(Symbol(),tf,k);
   
   t2=tm+tf*60;

   i=j;
   while (i>0 && iTime(Symbol(),mtf,i)<tm) {i--;w=true;}

   if (iTime(Symbol(),mtf,i)>t2) return (0);

   n=j; c1 = iHigh(Symbol(),mtf,j);
   if (tf==PERIOD_MN1)
     {
      while (i>=0 && TimeMonth(iTime(Symbol(),mtf,i))==TimeMonth(t))
        {
         if (c1<iHigh(Symbol(),mtf,i)) {c1=iHigh(Symbol(),mtf,i); n=i;}
         i--;
        }
     }
   else
     {
      for (i=j;i>=0 && iTime(Symbol(),mtf,i)<t2;i--)
        {
         if (c1<iHigh(Symbol(),mtf,i)) {c1=iHigh(Symbol(),mtf,i); n=i;}
        }
     }

   if (n>-1)
     {
      if (c1>=c-delta*Point && c1<=c+delta*Point)
        {
         newBar=true; 
         if (w && (c1>iHigh(Symbol(),mtf,j) || MathRound(c1/Point)!=MathRound(c/Point) || iTime(Symbol(),mtf,n)!=t)) w=false;
         if (w)
           {
            if (PeakCurrentTime)
              {
               numTF2=numTF;
              }
            else
              {
               numTF2=numTF1;
              }
            return (t);
           }
         else
           {
            if (Transformation)
              {
               if (PeakCurrentTime)
                 {
                  if (numTF>numTF0) numTF2=numTF0; else numTF2=numTF;
 
                  if (MathRound(cCena1/Point)==MathRound(c/Point))
                    {
                     coordinataCena1=iHigh(Symbol(),mtf,n);
                    }
                  else
                    {
                     coordinataCena2=iHigh(Symbol(),mtf,n);
                    }
                 }
              }
            else
              {
               if (PeakCurrentTime)
                 {
                  if (numTF<numTF0)
                    {
                     numTF2=numTF;
 
                     if (MathRound(cCena1/Point)==MathRound(c/Point))
                       {
                        coordinataCena1=iHigh(Symbol(),mtf,n);
                       }
                     else
                       {
                        coordinataCena2=iHigh(Symbol(),mtf,n);
                       }
                    }
                 }
              }
            return (iTime(Symbol(),mtf,n));
           }
        }
     }
  }
//--------------------------------------------------------
//  . .
//--------------------------------------------------------

//--------------------------------------------------------
//  . .
//    
//      newBar=false -   
//             true  -  
//--------------------------------------------------------
datetime search_low(int tf, datetime t, double c)
  {
   int j=0,k=0, i, n=-1, mtf;
   double c1;
   bool w=false;
   newBar=false; 

   if (Transformation)
     {
      if (numTF>numTF0) mtf=_tf[StrToInteger(numTF0)]; else mtf=Period();
     }
   else
     {
      mtf=Period();
     }

   if (t==iTime(Symbol(),mtf,0)) j=0; else j=iBarShift(Symbol(),mtf,t,false);
   if (t==iTime(Symbol(),tf,0)) k=0; else k=iBarShift(Symbol(),tf,t,false);
   datetime t2, tm=iTime(Symbol(),tf,k);
   
   t2=tm+tf*60;

   i=j;
   while (i>0 && iTime(Symbol(),mtf,i)<tm) {i--;w=true;}

   if (iTime(Symbol(),mtf,i)>t2) return (0);

   n=j; c1 = iLow(Symbol(),mtf,j);

   if (tf==PERIOD_MN1)
     {
      while (i>=0 && TimeMonth(iTime(Symbol(),mtf,i))==TimeMonth(t))
        {
         if (c1>iLow(Symbol(),mtf,i)) {c1=iLow(Symbol(),mtf,i); n=i;}
         i--;
        }
     }
   else
     {
      for (i=j;i>=0 && iTime(Symbol(),mtf,i)<t2;i--)
        {
         if (c1>iLow(Symbol(),mtf,i)) {c1=iLow(Symbol(),mtf,i); n=i;}
        }
     }

   if (n>-1)
     {
      if (c1<=c+delta*Point && c1>=c-delta*Point)
        {
         newBar=true; 
         if (w && (c1<iLow(Symbol(),mtf,j) || MathRound(c1/Point)!=MathRound(c/Point) || iTime(Symbol(),mtf,n)!=t)) w=false;
         if (w)
           {
            if (PeakCurrentTime)
              {
               numTF2=numTF;
              }
            else
              {
               numTF2=numTF1;
              }
            return (t);
           }
         else
           {
            if (Transformation)
              {
               if (PeakCurrentTime)
                 {
                  if (numTF>numTF0) numTF2=numTF0; else numTF2=numTF;

                  if (MathRound(cCena1/Point)==MathRound(c/Point))
                    {
                     coordinataCena1=iLow(Symbol(),mtf,n);
                    }
                  else
                    {
                     coordinataCena2=iLow(Symbol(),mtf,n);
                    }
                 }
              }
            else
              {
               if (PeakCurrentTime)
                 {
                  if (numTF<numTF0)
                    {
                     numTF2=numTF;
 
                     if (MathRound(cCena1/Point)==MathRound(c/Point))
                       {
                        coordinataCena1=iLow(Symbol(),mtf,n);
                       }
                     else
                       {
                        coordinataCena2=iLow(Symbol(),mtf,n);
                       }
                    }
                 }
              }
            return (iTime(Symbol(),mtf,n));
           }
        }
     }
  }
//--------------------------------------------------------
//  . .
//--------------------------------------------------------

//--------------------------------------------------------
//   . .
//    
//      newBar=false -   
//             true -  
//--------------------------------------------------------
datetime search_close(int tf, datetime t, double c)
  {
   int j=0,k=0, i, n=-1, mtf;
   double c1;
   newBar=false; 

   if (Transformation)
     {
      if (numTF>numTF0) mtf=_tf[StrToInteger(numTF0)]; else mtf=Period();
     }
   else
     {
      mtf=Period();
     }

   if (t==iTime(Symbol(),mtf,0)) j=0; else j=iBarShift(Symbol(),mtf,t,false);
   if (t==iTime(Symbol(),tf,0)) k=0; else k=iBarShift(Symbol(),tf,t,false);
   datetime t2, tm=iTime(Symbol(),tf,k);
   
   t2=tm+tf*60;

   i=j;
   while (i>0 &&  iTime(Symbol(),mtf,i)<tm) i--;

   if ( iTime(Symbol(),mtf,i)>t2) return (0);

   n=j;
   if (tf==PERIOD_MN1)
     {
      while (i>=0 && TimeMonth( iTime(Symbol(),mtf,i))==TimeMonth(t)) {n=i; i--;}
     }
   else
     {
      for (i=j;i>=0 &&  iTime(Symbol(),mtf,i)<t2;i--) n=i;
     }

   if (n>-1)
     {
      if (c>=iLow(Symbol(),mtf,n) && c<=iHigh(Symbol(),mtf,n))
        {
         newBar=true; 

         if (Transformation)
           {
            if (PeakCurrentTime)
              {
               if (numTF>numTF0) numTF2=numTF0; else numTF2=numTF;

               if (MathRound(cCena1/Point)==MathRound(c/Point))
                 {
                  coordinataCena1=iClose(Symbol(),mtf,n);
                 }
               else
                 {
                  coordinataCena2=iClose(Symbol(),mtf,n);
                 }
              }
           }
         else
           {
            if (PeakCurrentTime)
              {
               if (numTF<numTF0)
                 {
                  numTF2=numTF;

                  if (MathRound(cCena1/Point)==MathRound(c/Point))
                    {
                     coordinataCena1=iClose(Symbol(),mtf,n);
                    }
                  else
                    {
                     coordinataCena2=iClose(Symbol(),mtf,n);
                    }
                 }
              }
           }

//         if (PeakCurrentTime) numTF2=numTF; else numTF2=numTF1;
         return ( iTime(Symbol(),mtf,n));
        }
     }
  }
//--------------------------------------------------------
//   . .
//--------------------------------------------------------

//--------------------------------------------------------
//   . .
//--------------------------------------------------------
void counted_objects()
  {
   int i, count=0;

   for (i=0;i<col;i++)
     {
      if (_atl[i])
        {
         if (ObjectFind(_name[i])<0)
           {
            _atl[i]=false;
            count=i+1; break;
           }
        }
      else {count=i+1; break;}
     }

   if (count==0) count=col+1;

   counted_lines(count);
  }
//--------------------------------------------------------
//   . .
//--------------------------------------------------------

//--------------------------------------------------------
//   . .
//--------------------------------------------------------
void counted_lines(int count)
  {
   if (count>0 && count<10) countLines="00"+count;
   else if (count>9 && count<100) countLines="0"+count;
   else if (count>99 && count<1000) countLines=""+count;
   else countLines="***";
  }
//--------------------------------------------------------
//   . .
//--------------------------------------------------------

//--------------------------------------------------------
//  -. .
//--------------------------------------------------------
void Create_lines()
  {
/*
   int i=StrToInteger(StringSubstr(nameObj,4,3));

Print ("i=",i);
   if (i<=col && i>0)
     {
      if (_atl[i-1]) return;
     }
*/
   ObjectCreate(nameObj,OBJ_TREND,0,coordinataTime1,coordinataCena1,coordinataTime2,coordinataCena2);
   ObjectSetText(nameObj, countLines);
   ObjectSet(nameObj, OBJPROP_COLOR,aColorLines);
   ObjectSet(nameObj,OBJPROP_STYLE,aStyleLines);
   ObjectSet(nameObj,OBJPROP_WIDTH,aWidthLines);

   _writeArray(StrToInteger(countLines)-1);
   _NumberLines();
  }
//--------------------------------------------------------
//  -. .
//--------------------------------------------------------


//--------------------------------------------------------
//    . .
//--------------------------------------------------------
void coordinaty_lines()
  {
   int BarsPerChart=WindowBarsPerChart();
   int VisibleBarFirst=WindowFirstVisibleBar();

    if (VisibleBarFirst<BarsPerChart)
      {
       coordinataTime2=Time[0];
       coordinataTime1=Time[VisibleBarFirst/5];
      }
    else
      {
       coordinataTime2=Time[VisibleBarFirst-BarsPerChart+VisibleBarFirst/10];
       coordinataTime1=Time[VisibleBarFirst-BarsPerChart+VisibleBarFirst/5];
      }

   coordinataCena1=NormalizeDouble(WindowPriceMax()-(WindowPriceMax()-WindowPriceMin())/10,Digits);
   coordinataCena2=coordinataCena1;
   _cCenaAdd();
  }
//--------------------------------------------------------
//    . .
//--------------------------------------------------------


//--------------------------------------------------------
//  cCenaAdd. .
//--------------------------------------.------------------
void _cCenaAdd()
  {
   int i,j;
   cCenaAdd1="";   
   cCenaAdd2="";   

   j=StringLen(DoubleToStr(coordinataCena1,Digits));
   for (i=j;i<8;i++)
     {
      cCenaAdd1=cCenaAdd1+"0";
     }

   j=StringLen(DoubleToStr(coordinataCena2,Digits));
   for (i=j;i<8;i++)
     {
      cCenaAdd2=cCenaAdd2+"0";
     }
  }
//--------------------------------------------------------
//  cCenaAdd. .
//--------------------------------------------------------


//--------------------------------------------------------
//     . .
//--------------------------------------------------------
string time_str(datetime t)
  {
   string str;
   int i,len;
   str = ""+t;
   len = StringLen(str);
   switch (len)
     {
      case 10 : return (str);
      case  9 : return ("0"+str);
      case  8 : return ("00"+str);
      case  7 : return ("000"+str);
      case  6 : return ("0000"+str);
      case  5 : return ("00000"+str);
      case  4 : return ("000000"+str);
     }
  }
//--------------------------------------------------------
//     . .
//--------------------------------------------------------


//--------------------------------------------------------
//    . .
//   Integer.  http://forum.mql4.com/ru/7134
//--------------------------------------------------------
color fStrToColor(string aName)
  {
 
   color tColor[]={  Black, DarkGreen, DarkSlateGray, Olive, Green, Teal, Navy, Purple, 
                     Maroon, Indigo, MidnightBlue, DarkBlue, DarkOliveGreen, SaddleBrown, 
                     ForestGreen, OliveDrab, SeaGreen, DarkGoldenrod, DarkSlateBlue, 
                     Sienna, MediumBlue, Brown, DarkTurquoise, DimGray, LightSeaGreen, 
                     DarkViolet, FireBrick, MediumVioletRed, MediumSeaGreen, Chocolate, 
                     Crimson, SteelBlue, Goldenrod, MediumSpringGreen, LawnGreen, 
                     CadetBlue, DarkOrchid, YellowGreen, LimeGreen, OrangeRed, DarkOrange, 
                     Orange, Gold, Yellow, Chartreuse, Lime, SpringGreen, Aqua, DeepSkyBlue, 
                     Blue, Magenta, Red, Gray, SlateGray, Peru, BlueViolet, LightSlateGray, 
                     DeepPink, MediumTurquoise, DodgerBlue, Turquoise, RoyalBlue, SlateBlue, 
                     DarkKhaki, IndianRed, MediumOrchid, GreenYellow, MediumAquamarine, 
                     DarkSeaGreen, Tomato, RosyBrown, Orchid, MediumPurple, PaleVioletRed, 
                     Coral, CornflowerBlue, DarkGray, SandyBrown, MediumSlateBlue, Tan, 
                     DarkSalmon, BurlyWood, HotPink, Salmon, Violet, LightCoral, SkyBlue, 
                     LightSalmon, Plum, Khaki, LightGreen, Aquamarine, Silver, LightSkyBlue, 
                     LightSteelBlue, LightBlue, PaleGreen, Thistle, PowderBlue, PaleGoldenrod, 
                     PaleTurquoise, LightGray, Wheat, NavajoWhite, Moccasin, LightPink, 
                     Gainsboro, PeachPuff, Pink, Bisque, LightGoldenrod, BlanchedAlmond, 
                     LemonChiffon, Beige, AntiqueWhite, PapayaWhip, Cornsilk, LightYellow, 
                     LightCyan, Linen, Lavender, MistyRose, OldLace, WhiteSmoke, Seashell, 
                     Ivory, Honeydew, AliceBlue, LavenderBlush, MintCream, Snow, White
                  };  
   string tName[]={   "Black", "DarkGreen", "DarkSlateGray", "Olive", "Green", "Teal", "Navy", "Purple", 
                     "Maroon", "Indigo", "MidnightBlue", "DarkBlue", "DarkOliveGreen", "SaddleBrown", 
                     "ForestGreen", "OliveDrab", "SeaGreen", "DarkGoldenrod", "DarkSlateBlue", 
                     "Sienna", "MediumBlue", "Brown", "DarkTurquoise", "DimGray", "LightSeaGreen", 
                     "DarkViolet", "FireBrick", "MediumVioletRed", "MediumSeaGreen", "Chocolate", 
                     "Crimson", "SteelBlue", "Goldenrod", "MediumSpringGreen", "LawnGreen", 
                     "CadetBlue", "DarkOrchid", "YellowGreen", "LimeGreen", "OrangeRed", "DarkOrange", 
                     "Orange", "Gold", "Yellow", "Chartreuse", "Lime", "SpringGreen", "Aqua", "DeepSkyBlue", 
                     "Blue", "Magenta", "Red", "Gray", "SlateGray", "Peru", "BlueViolet", "LightSlateGray", 
                     "DeepPink", "MediumTurquoise", "DodgerBlue", "Turquoise", "RoyalBlue", "SlateBlue", 
                     "DarkKhaki", "IndianRed", "MediumOrchid", "GreenYellow", "MediumAquamarine", 
                     "DarkSeaGreen", "Tomato", "RosyBrown", "Orchid", "MediumPurple", "PaleVioletRed", 
                     "Coral", "CornflowerBlue", "DarkGray", "SandyBrown", "MediumSlateBlue", "Tan", 
                     "DarkSalmon", "BurlyWood", "HotPink", "Salmon", "Violet", "LightCoral", "SkyBlue", 
                     "LightSalmon", "Plum", "Khaki", "LightGreen", "Aquamarine", "Silver", "LightSkyBlue", 
                     "LightSteelBlue", "LightBlue", "PaleGreen", "Thistle", "PowderBlue", "PaleGoldenrod", 
                     "PaleTurquoise", "LightGray", "Wheat", "NavajoWhite", "Moccasin", "LightPink", 
                     "Gainsboro", "PeachPuff", "Pink", "Bisque", "LightGoldenrod", "BlanchedAlmond", 
                     "LemonChiffon", "Beige", "AntiqueWhite", "PapayaWhip", "Cornsilk", "LightYellow", 
                     "LightCyan", "Linen", "Lavender", "MistyRose", "OldLace", "WhiteSmoke", "Seashell", 
                     "Ivory", "Honeydew", "AliceBlue", "LavenderBlush", "MintCream", "Snow", "White"
                  };
   aName=StringTrimLeft(StringTrimRight(aName));      
   for(int i=0;i<ArraySize(tName);i++)
     {
      if(aName==tName[i])return(tColor[i]);
     }

   return(Red);                                     
  }
//--------------------------------------------------------
//    . .
//   Integer.  http://forum.mql4.com/ru/7134
//--------------------------------------------------------

//--------------------------------------------------------
//   . .
//--------------------------------------------------------
void delete_a_reaction()
  {
   int i, level=0, m=0;
   string txt;

   for (i=ObjectsTotal(); i>=0; i--)
     {
      txt=ObjectName(i);

      if (StringFind(txt,"Reaction1_"+countLines)>-1) ObjectDelete (txt);
      if (StringFind(txt,"Reaction2_"+countLines)>-1) ObjectDelete (txt);
      if (StringFind(txt,"Action1_"+countLines)>-1) ObjectDelete (txt);
      if (StringFind(txt,"Action2_"+countLines)>-1) ObjectDelete (txt);
      if (StringFind(txt,"nAct_"+countLines)>-1) ObjectDelete (txt);
      if (StringFind(txt,"PLOL_"+countLines+"R1")>-1) ObjectDelete (txt);
      if (StringFind(txt,"PLOL_"+countLines+"R2")>-1) ObjectDelete (txt);
      if (StringFind(txt,"PLOL_"+countLines+"A1")>-1) ObjectDelete (txt);
      if (StringFind(txt,"PLOL_"+countLines+"A2")>-1) ObjectDelete (txt);
      if (StringFind(txt,"Level_"+countLines)>-1) level++;
     }

   if (level>0)
     {
      Sizefi=level;
      ArrayResize(fi,level);
      ArrayResize(fitxt,level);
      ArrayResize(fitxt100,level);

      for (i=ObjectsTotal(); i>=0; i--)
        {
         txt=ObjectName(i);
         if (StringFind(txt,"Level_"+countLines)>-1)
           {
            fitxt100[m]=ObjectDescription(txt);
            fi[m]=StrToDouble(fitxt100[m])/100;
            ObjectDelete (txt);
            level--;
            m++;
            if (level==0) break;
           }
        }
     }

  }
//--------------------------------------------------------
//   . .
//--------------------------------------------------------

//--------------------------------------------------------
//  . .
//--------------------------------------------------------
int search_Low(int tf, int p1, int p2)
  {
   double c=0;
   int i, j;
   for (i=p1;i>=p2;i--)
     {
      if (c>iLow(Symbol(),tf,i)) {j=i; c=iLow(Symbol(),tf,i);}
     }
   return (j);
  }
//--------------------------------------------------------
//  . .
//--------------------------------------------------------

//--------------------------------------------------------
//  . .
//--------------------------------------------------------
int search_High(int tf, int p1, int p2)
  {
   double c=0;
   int i, j;
   for (i=p1;i>=p2;i--)
     {
      if (c<iHigh(Symbol(),tf,i)) {j=i; c=iHigh(Symbol(),tf,i);}
     }
   return (j);
  }
//--------------------------------------------------------
//  . .
//--------------------------------------------------------

//--------------------------------------------------------
//  . .
//--------------------------------------------------------
int number_Obj(string txt)
  {
   for (int i=ObjectsTotal(); i>=0; i--)
     {
      if (StringFind(ObjectName(i),txt)>-1) return (i);
     }
   return (-1);
  }
//--------------------------------------------------------
//  . .
//--------------------------------------------------------

//--------------------------------------------------------
//   . .
//--------------------------------------------------------
void  RefreshAccountInfo()
   {
   static int acc=0;
   if (accountCompany!=AccountCompany()|| acc!=AccountNumber()) 
      {
       if (acc>0)
         {
          chartchange=2;
          changeAccount=true;
          moveATL=true;
         }
//      Print("AccountNumber()=",AccountNumber());
//      Print("AccountCompany()=",AccountCompany());
      accountCompany=AccountCompany();
      acc=AccountNumber();
      }
   }
//--------------------------------------------------------
//   . .
//--------------------------------------------------------

//--------------------------------------------------------
//   . .
//--------------------------------------------------------
void _NumberLines()
  {
   string NumberLines, txt, txt1="";
   txt=StringSubstr(nameObj,13,1);

   if (txt=="1") txt1="LT_";
   else if (txt=="2") txt1="LC_";
   else if (txt=="3") txt1="LP_";

   NumberLines="_NumberLines_"+countLines;
   ObjectDelete(NumberLines);

   if (iBarShift(Symbol(),Period(),coordinataTime1,false)==iBarShift(Symbol(),Period(),coordinataTime2,false)) return;

   if (ShowNumberLines)
     {
      ObjectCreate(NumberLines,OBJ_TEXT,0,coordinataTime1,coordinataCena1);
      ObjectSetText(NumberLines, txt1+StrToInteger(countLines),SizeLevelLines,"Arial",aColorLines);
     }
  }
//--------------------------------------------------------
//   . .
//--------------------------------------------------------

//--------------------------------------------------------
//    . .
//--------------------------------------------------------
void _infoLines()
  {
   int k=infoLines-1, tf0,tf1, h1, h2, numFr;
   tf0=_numTf[k,0]; tf1=_numTf[k,1];
   string info="\n\nNumberLines = "+infoLines+"  /  min TF : "+txtTF[tf0]+"  /  max TF : "+txtTF[tf1]+"\n";
   string info1=" / ", info2="";
   bool yes=false;
   string tf;
   datetime mtf;

   if (infoLines>col || infoLines<=0) {infoVariants=-1; return;}
   if (!_atl[k]) {infoVariants=0; return;}

   if (infoVariants==0)
     {
      if (_friend[k]>0)
        {
         info2="NumberLinesConnected = "+_friend[k]+"\n";
         info=info+info2;
        }

      if (_pl[k,0]>0)
        {
         info2="ShowReactionLines = "+_pl[k,0];
         h1=MathRound(MathAbs(_h1[k,0])/Point);
         h2=MathRound(MathAbs(_h1[k,1])/Point);
         if (h1>0)
           {
            info=info+info2+"  /  H1 = "+h1;
            if (h2>0 && (_pl[k,0]==1 || _pl[k,0]==4 || _pl[k,0]==6 || _pl[k,0]==8))
              {
               info=info+"  /  H2 = "+h2;
              }
           }

         if (h1>0 || h2>0)
           {
            info=info+"\n";
            yes=false;
           }
         else
           {
            info=info+info2;
            yes=true;
           }
        }

      if (_pl[k,1]>0)
        {
         info2="FiboTime = "+_pl[k,1];
         if (yes)
           {
            info=info+info1;
           }

         info=info+info2;
         yes=true;
        }

      if (_pl[k,2]>0)
        {
         info2="PriceLabelOnLines = "+_pl[k,2];
         if (yes)
           {
            info=info+info1;
           }

         info=info+info2;
         yes=true;
        }

      if (_pl[k,3]>0)
        {
         if (_pl[k,3]==1)
           {
            info2="LT";
           }
         else if (_pl[k,3]==2)
           {
            info2="LC";
           }
         else if (_pl[k,3]==3)
           {
            info2="LP";
           }

         if (yes)
           {
            info2=info1;
           }
         else
         info=info+"NameLines = "+info2;
         yes=true;
        }

      if (_pl[k,4]>0)
        {
         info2="VariantsOfProcessingLines = "+_pl[k,4];
         if (yes)
           {
            info=info+info1+info2;
           }
         else
           {
            info=info+info2;
           }
         yes=true;
        }

      if (_pl[k,3]==3)
        {
         numFr=_friend[k]-1;
         if (_numTf[k,0]<=_numTf[numFr,0])
           {
            tf=txtTF[_numTf[numFr,0]];
            mtf=_tf[_numTf[numFr,0]];
           }
         else
           {
            tf=txtTF[_numTf[k,0]];
            mtf=_tf[_numTf[k,0]];
           }

         if (_coordinataX(numFr, k, mtf))
           {
            info=info+"\nX   "+tf+"  :  "+DoubleToStr(cenaX,Digits)+"  :  "+TimeToStr(timeX,TIME_DATE|TIME_MINUTES);
           }
        }

      infoLines=0;
     }
   else if (infoVariants==1)
     {
     }

   Comment(info);
  }
//--------------------------------------------------------
//    . .
//--------------------------------------------------------


//--------------------------------------------------------
//       . .
//--------------------------------------------------------
bool _coordinataX(int numFr, int k, datetime mtf)
  {
   int pointLC1, pointLC2, pointLP1, pointLP2, _bar;
   double tangens_LC, tangens_LP, x1, x2, x3, cena;
   datetime deltaT;

   if (numFr<0) return (false);

   pointLC1=iBarShift(Symbol(),mtf,_time[numFr,0],false);
   pointLC2=iBarShift(Symbol(),mtf,_time[numFr,1],false);
   pointLP1=iBarShift(Symbol(),mtf,_time[k,0],false);
   pointLP2=iBarShift(Symbol(),mtf,_time[k,1],false);

   if ((pointLC1==pointLC2) || (pointLP1==pointLP2)) return (false);

   tangens_LC=(_cena[numFr,1]-_cena[numFr,0])/(pointLC1-pointLC2);
   tangens_LP=(_cena[k,1]-_cena[k,0])/(pointLP1-pointLP2);

   if (tangens_LP==tangens_LC || tangens_LP==0) return (false);

   if (MathAbs(tangens_LP)>MathAbs(tangens_LC))
     {
      x1=_cena[numFr,0]+tangens_LC*(pointLC1-pointLP1);
      x2=_cena[k,0];
      x3=(x1*tangens_LP - x2*tangens_LC)/(tangens_LP-tangens_LC);
      cena=(x3-x2)/tangens_LP;
      _bar=MathFloor(cena);
      deltaT=MathRound(mtf*60*(cena-_bar));
      cenaX=_cena[k,0]+tangens_LP*_bar;
      cenaX=x3;

      if (pointLP1>=_bar)
        {
         timeX=iTime(Symbol(),mtf,pointLP1-_bar)+deltaT;
        }
      else
        {
         timeX=iTime(Symbol(),mtf,0)+(_bar-pointLP1)*mtf*60+deltaT;
        }
     }
   else return (false);
   
   return (true);
  }
//--------------------------------------------------------
//       . .
//--------------------------------------------------------


//--------------------------------------------------------
//  ,      . .
//--------------------------------------------------------
string _period(int tf)
  {
   switch (tf)
     {
      case 1     : {return (TF[0]);}
      case 5     : {return (TF[1]);}
      case 15    : {return (TF[2]);}
      case 30    : {return (TF[3]);}
      case 60    : {return (TF[4]);}
      case 240   : {return (TF[5]);}
      case 1440  : {return (TF[6]);}
      case 10080 : {return (TF[7]);}
      case 43200 : {return (TF[8]);}
     }
  }
//--------------------------------------------------------
//  ,      . .
//--------------------------------------------------------

